/* This file was generated by SableCC (http://www.sablecc.org/). */

package org.sablecc.sablecc.parser;

import java.io.DataInputStream;
import java.io.BufferedInputStream;
import java.io.InputStream;
import java.io.IOException;
import java.util.Arrays;
import java.util.Collections;
import java.util.LinkedList;
import java.util.List;
import java.util.ListIterator;

import de.hhu.stups.sablecc.patch.IParser;
import de.hhu.stups.sablecc.patch.PositionedNode;

import org.sablecc.sablecc.lexer.Lexer;
import org.sablecc.sablecc.lexer.LexerException;
import org.sablecc.sablecc.node.*;

@SuppressWarnings({"unchecked", "unused"})
public class Parser implements IParser
{
    private final Lexer lexer;
    private final ListIterator<State> stack = new LinkedList<State>().listIterator();
    private final TokenIndex converter = new TokenIndex();

    private static final int SHIFT = 0;
    private static final int REDUCE = 1;
    private static final int ACCEPT = 2;
    private static final int ERROR = 3;

    public Parser(Lexer lexer)
    {
        this.lexer = lexer;
    }

    private void computePositions(PositionedNode node, List<?> beginNodeList, List<?> endNodeList) {
        // This method should only ever be called for newly created AST nodes (that are not tokens).
        assert !(node instanceof Token);
        assert node.getStartPos() == null;
        assert node.getEndPos() == null;

        PositionedNode beginNode = findBeginNode(beginNodeList);
        node.setStartPos(beginNode.getStartPos());

        PositionedNode endNode = findEndNode(endNodeList);
        node.setEndPos(endNode.getEndPos());
    }

    private PositionedNode findBeginNode(final List<?> list) {
        Object first = list.get(0);
        if (first instanceof List<?>) {
            List<?> list2 = (List<?>) first;
            return (PositionedNode)list2.get(0);
        }

        return (PositionedNode)first;
    }

    private PositionedNode findEndNode(final List<?> list) {
        Object last = list.get(list.size() - 1);
        if (last instanceof List<?>) {
            final List<?> list2 = (List<?>) last;
            return (PositionedNode)list2.get(list2.size() - 1);
        }

        return (PositionedNode)last;
    }

    private void push(int numstate, List<?> listNode)
    {
        if(!this.stack.hasNext())
        {
            this.stack.add(new State(numstate, listNode));
            return;
        }

        State s = this.stack.next();
        s.state = numstate;
        s.nodes = listNode;
    }

    private int goTo(int index)
    {
        int state = state();
        int[][] table = gotoTable[index];
        int low = 1;
        int high = table.length - 1;
        int value = table[0][1];

        while(low <= high)
        {
            int middle = (low + high) >>> 1;

            if(state < table[middle][0])
            {
                high = middle - 1;
            }
            else if(state > table[middle][0])
            {
                low = middle + 1;
            }
            else
            {
                value = table[middle][1];
                break;
            }
        }

        return value;
    }

    private int state()
    {
        State s = this.stack.previous();
        this.stack.next();
        return s.state;
    }

    private List<?> pop()
    {
        return this.stack.previous().nodes;
    }

    private int index(Switchable token)
    {
        this.converter.index = -1;
        token.apply(this.converter);
        return this.converter.index;
    }


    public Start parse() throws ParserException, LexerException, IOException
    {
        push(0, null);
        while(true)
        {
            Token lastToken = this.lexer.peek();
            int index = index(lastToken);
            while(index == -1)
            {
                // this is an ignored token
                this.lexer.next();
                lastToken = this.lexer.peek();
                index = index(lastToken);
            }

            int state = state();
            int[][] table = actionTable[state];
            int action = table[0][1];
            int destination = table[0][2];

            int low = 1;
            int high = table.length - 1;

            while(low <= high)
            {
                int middle = (low + high) >>> 1;

                if(index < table[middle][0])
                {
                    high = middle - 1;
                }
                else if(index > table[middle][0])
                {
                    low = middle + 1;
                }
                else
                {
                    action = table[middle][1];
                    destination = table[middle][2];
                    break;
                }
            }

            switch(action)
            {
                case SHIFT:
                    push(destination, Collections.singletonList(this.lexer.next()));
                    break;

                case REDUCE:
                    switch(destination)
                    {
                        case 0: /* reduce AAgrammar1Grammar */
                        {
                            List<?> list = new0();
                            push(goTo(0), list);
                        }
                        break;
                        case 1: /* reduce AAgrammar2Grammar */
                        {
                            List<?> list = new1();
                            push(goTo(0), list);
                        }
                        break;
                        case 2: /* reduce AAgrammar3Grammar */
                        {
                            List<?> list = new2();
                            push(goTo(0), list);
                        }
                        break;
                        case 3: /* reduce AAgrammar4Grammar */
                        {
                            List<?> list = new3();
                            push(goTo(0), list);
                        }
                        break;
                        case 4: /* reduce AAgrammar5Grammar */
                        {
                            List<?> list = new4();
                            push(goTo(0), list);
                        }
                        break;
                        case 5: /* reduce AAgrammar6Grammar */
                        {
                            List<?> list = new5();
                            push(goTo(0), list);
                        }
                        break;
                        case 6: /* reduce AAgrammar7Grammar */
                        {
                            List<?> list = new6();
                            push(goTo(0), list);
                        }
                        break;
                        case 7: /* reduce AAgrammar8Grammar */
                        {
                            List<?> list = new7();
                            push(goTo(0), list);
                        }
                        break;
                        case 8: /* reduce AAgrammar9Grammar */
                        {
                            List<?> list = new8();
                            push(goTo(0), list);
                        }
                        break;
                        case 9: /* reduce AAgrammar10Grammar */
                        {
                            List<?> list = new9();
                            push(goTo(0), list);
                        }
                        break;
                        case 10: /* reduce AAgrammar11Grammar */
                        {
                            List<?> list = new10();
                            push(goTo(0), list);
                        }
                        break;
                        case 11: /* reduce AAgrammar12Grammar */
                        {
                            List<?> list = new11();
                            push(goTo(0), list);
                        }
                        break;
                        case 12: /* reduce AAgrammar13Grammar */
                        {
                            List<?> list = new12();
                            push(goTo(0), list);
                        }
                        break;
                        case 13: /* reduce AAgrammar14Grammar */
                        {
                            List<?> list = new13();
                            push(goTo(0), list);
                        }
                        break;
                        case 14: /* reduce AAgrammar15Grammar */
                        {
                            List<?> list = new14();
                            push(goTo(0), list);
                        }
                        break;
                        case 15: /* reduce AAgrammar16Grammar */
                        {
                            List<?> list = new15();
                            push(goTo(0), list);
                        }
                        break;
                        case 16: /* reduce AAgrammar17Grammar */
                        {
                            List<?> list = new16();
                            push(goTo(0), list);
                        }
                        break;
                        case 17: /* reduce AAgrammar18Grammar */
                        {
                            List<?> list = new17();
                            push(goTo(0), list);
                        }
                        break;
                        case 18: /* reduce AAgrammar19Grammar */
                        {
                            List<?> list = new18();
                            push(goTo(0), list);
                        }
                        break;
                        case 19: /* reduce AAgrammar20Grammar */
                        {
                            List<?> list = new19();
                            push(goTo(0), list);
                        }
                        break;
                        case 20: /* reduce AAgrammar21Grammar */
                        {
                            List<?> list = new20();
                            push(goTo(0), list);
                        }
                        break;
                        case 21: /* reduce AAgrammar22Grammar */
                        {
                            List<?> list = new21();
                            push(goTo(0), list);
                        }
                        break;
                        case 22: /* reduce AAgrammar23Grammar */
                        {
                            List<?> list = new22();
                            push(goTo(0), list);
                        }
                        break;
                        case 23: /* reduce AAgrammar24Grammar */
                        {
                            List<?> list = new23();
                            push(goTo(0), list);
                        }
                        break;
                        case 24: /* reduce AAgrammar25Grammar */
                        {
                            List<?> list = new24();
                            push(goTo(0), list);
                        }
                        break;
                        case 25: /* reduce AAgrammar26Grammar */
                        {
                            List<?> list = new25();
                            push(goTo(0), list);
                        }
                        break;
                        case 26: /* reduce AAgrammar27Grammar */
                        {
                            List<?> list = new26();
                            push(goTo(0), list);
                        }
                        break;
                        case 27: /* reduce AAgrammar28Grammar */
                        {
                            List<?> list = new27();
                            push(goTo(0), list);
                        }
                        break;
                        case 28: /* reduce AAgrammar29Grammar */
                        {
                            List<?> list = new28();
                            push(goTo(0), list);
                        }
                        break;
                        case 29: /* reduce AAgrammar30Grammar */
                        {
                            List<?> list = new29();
                            push(goTo(0), list);
                        }
                        break;
                        case 30: /* reduce AAgrammar31Grammar */
                        {
                            List<?> list = new30();
                            push(goTo(0), list);
                        }
                        break;
                        case 31: /* reduce AAgrammar32Grammar */
                        {
                            List<?> list = new31();
                            push(goTo(0), list);
                        }
                        break;
                        case 32: /* reduce AAgrammar33Grammar */
                        {
                            List<?> list = new32();
                            push(goTo(0), list);
                        }
                        break;
                        case 33: /* reduce AAgrammar34Grammar */
                        {
                            List<?> list = new33();
                            push(goTo(0), list);
                        }
                        break;
                        case 34: /* reduce AAgrammar35Grammar */
                        {
                            List<?> list = new34();
                            push(goTo(0), list);
                        }
                        break;
                        case 35: /* reduce AAgrammar36Grammar */
                        {
                            List<?> list = new35();
                            push(goTo(0), list);
                        }
                        break;
                        case 36: /* reduce AAgrammar37Grammar */
                        {
                            List<?> list = new36();
                            push(goTo(0), list);
                        }
                        break;
                        case 37: /* reduce AAgrammar38Grammar */
                        {
                            List<?> list = new37();
                            push(goTo(0), list);
                        }
                        break;
                        case 38: /* reduce AAgrammar39Grammar */
                        {
                            List<?> list = new38();
                            push(goTo(0), list);
                        }
                        break;
                        case 39: /* reduce AAgrammar40Grammar */
                        {
                            List<?> list = new39();
                            push(goTo(0), list);
                        }
                        break;
                        case 40: /* reduce AAgrammar41Grammar */
                        {
                            List<?> list = new40();
                            push(goTo(0), list);
                        }
                        break;
                        case 41: /* reduce AAgrammar42Grammar */
                        {
                            List<?> list = new41();
                            push(goTo(0), list);
                        }
                        break;
                        case 42: /* reduce AAgrammar43Grammar */
                        {
                            List<?> list = new42();
                            push(goTo(0), list);
                        }
                        break;
                        case 43: /* reduce AAgrammar44Grammar */
                        {
                            List<?> list = new43();
                            push(goTo(0), list);
                        }
                        break;
                        case 44: /* reduce AAgrammar45Grammar */
                        {
                            List<?> list = new44();
                            push(goTo(0), list);
                        }
                        break;
                        case 45: /* reduce AAgrammar46Grammar */
                        {
                            List<?> list = new45();
                            push(goTo(0), list);
                        }
                        break;
                        case 46: /* reduce AAgrammar47Grammar */
                        {
                            List<?> list = new46();
                            push(goTo(0), list);
                        }
                        break;
                        case 47: /* reduce AAgrammar48Grammar */
                        {
                            List<?> list = new47();
                            push(goTo(0), list);
                        }
                        break;
                        case 48: /* reduce AAgrammar49Grammar */
                        {
                            List<?> list = new48();
                            push(goTo(0), list);
                        }
                        break;
                        case 49: /* reduce AAgrammar50Grammar */
                        {
                            List<?> list = new49();
                            push(goTo(0), list);
                        }
                        break;
                        case 50: /* reduce AAgrammar51Grammar */
                        {
                            List<?> list = new50();
                            push(goTo(0), list);
                        }
                        break;
                        case 51: /* reduce AAgrammar52Grammar */
                        {
                            List<?> list = new51();
                            push(goTo(0), list);
                        }
                        break;
                        case 52: /* reduce AAgrammar53Grammar */
                        {
                            List<?> list = new52();
                            push(goTo(0), list);
                        }
                        break;
                        case 53: /* reduce AAgrammar54Grammar */
                        {
                            List<?> list = new53();
                            push(goTo(0), list);
                        }
                        break;
                        case 54: /* reduce AAgrammar55Grammar */
                        {
                            List<?> list = new54();
                            push(goTo(0), list);
                        }
                        break;
                        case 55: /* reduce AAgrammar56Grammar */
                        {
                            List<?> list = new55();
                            push(goTo(0), list);
                        }
                        break;
                        case 56: /* reduce AAgrammar57Grammar */
                        {
                            List<?> list = new56();
                            push(goTo(0), list);
                        }
                        break;
                        case 57: /* reduce AAgrammar58Grammar */
                        {
                            List<?> list = new57();
                            push(goTo(0), list);
                        }
                        break;
                        case 58: /* reduce AAgrammar59Grammar */
                        {
                            List<?> list = new58();
                            push(goTo(0), list);
                        }
                        break;
                        case 59: /* reduce AAgrammar60Grammar */
                        {
                            List<?> list = new59();
                            push(goTo(0), list);
                        }
                        break;
                        case 60: /* reduce AAgrammar61Grammar */
                        {
                            List<?> list = new60();
                            push(goTo(0), list);
                        }
                        break;
                        case 61: /* reduce AAgrammar62Grammar */
                        {
                            List<?> list = new61();
                            push(goTo(0), list);
                        }
                        break;
                        case 62: /* reduce AAgrammar63Grammar */
                        {
                            List<?> list = new62();
                            push(goTo(0), list);
                        }
                        break;
                        case 63: /* reduce AAgrammar64Grammar */
                        {
                            List<?> list = new63();
                            push(goTo(0), list);
                        }
                        break;
                        case 64: /* reduce AAgrammar65Grammar */
                        {
                            List<?> list = new64();
                            push(goTo(0), list);
                        }
                        break;
                        case 65: /* reduce AAgrammar66Grammar */
                        {
                            List<?> list = new65();
                            push(goTo(0), list);
                        }
                        break;
                        case 66: /* reduce AAgrammar67Grammar */
                        {
                            List<?> list = new66();
                            push(goTo(0), list);
                        }
                        break;
                        case 67: /* reduce AAgrammar68Grammar */
                        {
                            List<?> list = new67();
                            push(goTo(0), list);
                        }
                        break;
                        case 68: /* reduce AAgrammar69Grammar */
                        {
                            List<?> list = new68();
                            push(goTo(0), list);
                        }
                        break;
                        case 69: /* reduce AAgrammar70Grammar */
                        {
                            List<?> list = new69();
                            push(goTo(0), list);
                        }
                        break;
                        case 70: /* reduce AAgrammar71Grammar */
                        {
                            List<?> list = new70();
                            push(goTo(0), list);
                        }
                        break;
                        case 71: /* reduce AAgrammar72Grammar */
                        {
                            List<?> list = new71();
                            push(goTo(0), list);
                        }
                        break;
                        case 72: /* reduce AAgrammar73Grammar */
                        {
                            List<?> list = new72();
                            push(goTo(0), list);
                        }
                        break;
                        case 73: /* reduce AAgrammar74Grammar */
                        {
                            List<?> list = new73();
                            push(goTo(0), list);
                        }
                        break;
                        case 74: /* reduce AAgrammar75Grammar */
                        {
                            List<?> list = new74();
                            push(goTo(0), list);
                        }
                        break;
                        case 75: /* reduce AAgrammar76Grammar */
                        {
                            List<?> list = new75();
                            push(goTo(0), list);
                        }
                        break;
                        case 76: /* reduce AAgrammar77Grammar */
                        {
                            List<?> list = new76();
                            push(goTo(0), list);
                        }
                        break;
                        case 77: /* reduce AAgrammar78Grammar */
                        {
                            List<?> list = new77();
                            push(goTo(0), list);
                        }
                        break;
                        case 78: /* reduce AAgrammar79Grammar */
                        {
                            List<?> list = new78();
                            push(goTo(0), list);
                        }
                        break;
                        case 79: /* reduce AAgrammar80Grammar */
                        {
                            List<?> list = new79();
                            push(goTo(0), list);
                        }
                        break;
                        case 80: /* reduce AAgrammar81Grammar */
                        {
                            List<?> list = new80();
                            push(goTo(0), list);
                        }
                        break;
                        case 81: /* reduce AAgrammar82Grammar */
                        {
                            List<?> list = new81();
                            push(goTo(0), list);
                        }
                        break;
                        case 82: /* reduce AAgrammar83Grammar */
                        {
                            List<?> list = new82();
                            push(goTo(0), list);
                        }
                        break;
                        case 83: /* reduce AAgrammar84Grammar */
                        {
                            List<?> list = new83();
                            push(goTo(0), list);
                        }
                        break;
                        case 84: /* reduce AAgrammar85Grammar */
                        {
                            List<?> list = new84();
                            push(goTo(0), list);
                        }
                        break;
                        case 85: /* reduce AAgrammar86Grammar */
                        {
                            List<?> list = new85();
                            push(goTo(0), list);
                        }
                        break;
                        case 86: /* reduce AAgrammar87Grammar */
                        {
                            List<?> list = new86();
                            push(goTo(0), list);
                        }
                        break;
                        case 87: /* reduce AAgrammar88Grammar */
                        {
                            List<?> list = new87();
                            push(goTo(0), list);
                        }
                        break;
                        case 88: /* reduce AAgrammar89Grammar */
                        {
                            List<?> list = new88();
                            push(goTo(0), list);
                        }
                        break;
                        case 89: /* reduce AAgrammar90Grammar */
                        {
                            List<?> list = new89();
                            push(goTo(0), list);
                        }
                        break;
                        case 90: /* reduce AAgrammar91Grammar */
                        {
                            List<?> list = new90();
                            push(goTo(0), list);
                        }
                        break;
                        case 91: /* reduce AAgrammar92Grammar */
                        {
                            List<?> list = new91();
                            push(goTo(0), list);
                        }
                        break;
                        case 92: /* reduce AAgrammar93Grammar */
                        {
                            List<?> list = new92();
                            push(goTo(0), list);
                        }
                        break;
                        case 93: /* reduce AAgrammar94Grammar */
                        {
                            List<?> list = new93();
                            push(goTo(0), list);
                        }
                        break;
                        case 94: /* reduce AAgrammar95Grammar */
                        {
                            List<?> list = new94();
                            push(goTo(0), list);
                        }
                        break;
                        case 95: /* reduce AAgrammar96Grammar */
                        {
                            List<?> list = new95();
                            push(goTo(0), list);
                        }
                        break;
                        case 96: /* reduce AAgrammar97Grammar */
                        {
                            List<?> list = new96();
                            push(goTo(0), list);
                        }
                        break;
                        case 97: /* reduce AAgrammar98Grammar */
                        {
                            List<?> list = new97();
                            push(goTo(0), list);
                        }
                        break;
                        case 98: /* reduce AAgrammar99Grammar */
                        {
                            List<?> list = new98();
                            push(goTo(0), list);
                        }
                        break;
                        case 99: /* reduce AAgrammar100Grammar */
                        {
                            List<?> list = new99();
                            push(goTo(0), list);
                        }
                        break;
                        case 100: /* reduce AAgrammar101Grammar */
                        {
                            List<?> list = new100();
                            push(goTo(0), list);
                        }
                        break;
                        case 101: /* reduce AAgrammar102Grammar */
                        {
                            List<?> list = new101();
                            push(goTo(0), list);
                        }
                        break;
                        case 102: /* reduce AAgrammar103Grammar */
                        {
                            List<?> list = new102();
                            push(goTo(0), list);
                        }
                        break;
                        case 103: /* reduce AAgrammar104Grammar */
                        {
                            List<?> list = new103();
                            push(goTo(0), list);
                        }
                        break;
                        case 104: /* reduce AAgrammar105Grammar */
                        {
                            List<?> list = new104();
                            push(goTo(0), list);
                        }
                        break;
                        case 105: /* reduce AAgrammar106Grammar */
                        {
                            List<?> list = new105();
                            push(goTo(0), list);
                        }
                        break;
                        case 106: /* reduce AAgrammar107Grammar */
                        {
                            List<?> list = new106();
                            push(goTo(0), list);
                        }
                        break;
                        case 107: /* reduce AAgrammar108Grammar */
                        {
                            List<?> list = new107();
                            push(goTo(0), list);
                        }
                        break;
                        case 108: /* reduce AAgrammar109Grammar */
                        {
                            List<?> list = new108();
                            push(goTo(0), list);
                        }
                        break;
                        case 109: /* reduce AAgrammar110Grammar */
                        {
                            List<?> list = new109();
                            push(goTo(0), list);
                        }
                        break;
                        case 110: /* reduce AAgrammar111Grammar */
                        {
                            List<?> list = new110();
                            push(goTo(0), list);
                        }
                        break;
                        case 111: /* reduce AAgrammar112Grammar */
                        {
                            List<?> list = new111();
                            push(goTo(0), list);
                        }
                        break;
                        case 112: /* reduce AAgrammar113Grammar */
                        {
                            List<?> list = new112();
                            push(goTo(0), list);
                        }
                        break;
                        case 113: /* reduce AAgrammar114Grammar */
                        {
                            List<?> list = new113();
                            push(goTo(0), list);
                        }
                        break;
                        case 114: /* reduce AAgrammar115Grammar */
                        {
                            List<?> list = new114();
                            push(goTo(0), list);
                        }
                        break;
                        case 115: /* reduce AAgrammar116Grammar */
                        {
                            List<?> list = new115();
                            push(goTo(0), list);
                        }
                        break;
                        case 116: /* reduce AAgrammar117Grammar */
                        {
                            List<?> list = new116();
                            push(goTo(0), list);
                        }
                        break;
                        case 117: /* reduce AAgrammar118Grammar */
                        {
                            List<?> list = new117();
                            push(goTo(0), list);
                        }
                        break;
                        case 118: /* reduce AAgrammar119Grammar */
                        {
                            List<?> list = new118();
                            push(goTo(0), list);
                        }
                        break;
                        case 119: /* reduce AAgrammar120Grammar */
                        {
                            List<?> list = new119();
                            push(goTo(0), list);
                        }
                        break;
                        case 120: /* reduce AAgrammar121Grammar */
                        {
                            List<?> list = new120();
                            push(goTo(0), list);
                        }
                        break;
                        case 121: /* reduce AAgrammar122Grammar */
                        {
                            List<?> list = new121();
                            push(goTo(0), list);
                        }
                        break;
                        case 122: /* reduce AAgrammar123Grammar */
                        {
                            List<?> list = new122();
                            push(goTo(0), list);
                        }
                        break;
                        case 123: /* reduce AAgrammar124Grammar */
                        {
                            List<?> list = new123();
                            push(goTo(0), list);
                        }
                        break;
                        case 124: /* reduce AAgrammar125Grammar */
                        {
                            List<?> list = new124();
                            push(goTo(0), list);
                        }
                        break;
                        case 125: /* reduce AAgrammar126Grammar */
                        {
                            List<?> list = new125();
                            push(goTo(0), list);
                        }
                        break;
                        case 126: /* reduce AAgrammar127Grammar */
                        {
                            List<?> list = new126();
                            push(goTo(0), list);
                        }
                        break;
                        case 127: /* reduce AAgrammar128Grammar */
                        {
                            List<?> list = new127();
                            push(goTo(0), list);
                        }
                        break;
                        case 128: /* reduce APackage */
                        {
                            List<?> list = new128();
                            push(goTo(1), list);
                        }
                        break;
                        case 129: /* reduce AApkgname1PkgName */
                        {
                            List<?> list = new129();
                            push(goTo(2), list);
                        }
                        break;
                        case 130: /* reduce AApkgname2PkgName */
                        {
                            List<?> list = new130();
                            push(goTo(2), list);
                        }
                        break;
                        case 131: /* reduce APkgNameTail */
                        {
                            List<?> list = new131();
                            push(goTo(3), list);
                        }
                        break;
                        case 132: /* reduce AHelpers */
                        {
                            List<?> list = new132();
                            push(goTo(4), list);
                        }
                        break;
                        case 133: /* reduce AHelperDef */
                        {
                            List<?> list = new133();
                            push(goTo(5), list);
                        }
                        break;
                        case 134: /* reduce AStates */
                        {
                            List<?> list = new134();
                            push(goTo(6), list);
                        }
                        break;
                        case 135: /* reduce AAidlist1IdList */
                        {
                            List<?> list = new135();
                            push(goTo(7), list);
                        }
                        break;
                        case 136: /* reduce AAidlist2IdList */
                        {
                            List<?> list = new136();
                            push(goTo(7), list);
                        }
                        break;
                        case 137: /* reduce AIdListTail */
                        {
                            List<?> list = new137();
                            push(goTo(8), list);
                        }
                        break;
                        case 138: /* reduce ATokens */
                        {
                            List<?> list = new138();
                            push(goTo(9), list);
                        }
                        break;
                        case 139: /* reduce AAtokendef1TokenDef */
                        {
                            List<?> list = new139();
                            push(goTo(10), list);
                        }
                        break;
                        case 140: /* reduce AAtokendef2TokenDef */
                        {
                            List<?> list = new140();
                            push(goTo(10), list);
                        }
                        break;
                        case 141: /* reduce AAtokendef3TokenDef */
                        {
                            List<?> list = new141();
                            push(goTo(10), list);
                        }
                        break;
                        case 142: /* reduce AAtokendef4TokenDef */
                        {
                            List<?> list = new142();
                            push(goTo(10), list);
                        }
                        break;
                        case 143: /* reduce AAstatelist1StateList */
                        {
                            List<?> list = new143();
                            push(goTo(11), list);
                        }
                        break;
                        case 144: /* reduce AAstatelist2StateList */
                        {
                            List<?> list = new144();
                            push(goTo(11), list);
                        }
                        break;
                        case 145: /* reduce AAstatelist3StateList */
                        {
                            List<?> list = new145();
                            push(goTo(11), list);
                        }
                        break;
                        case 146: /* reduce AAstatelist4StateList */
                        {
                            List<?> list = new146();
                            push(goTo(11), list);
                        }
                        break;
                        case 147: /* reduce AAstatelisttail1StateListTail */
                        {
                            List<?> list = new147();
                            push(goTo(12), list);
                        }
                        break;
                        case 148: /* reduce AAstatelisttail2StateListTail */
                        {
                            List<?> list = new148();
                            push(goTo(12), list);
                        }
                        break;
                        case 149: /* reduce ATransition */
                        {
                            List<?> list = new149();
                            push(goTo(13), list);
                        }
                        break;
                        case 150: /* reduce AAigntokens1IgnTokens */
                        {
                            List<?> list = new150();
                            push(goTo(14), list);
                        }
                        break;
                        case 151: /* reduce AAigntokens2IgnTokens */
                        {
                            List<?> list = new151();
                            push(goTo(14), list);
                        }
                        break;
                        case 152: /* reduce ALookAhead */
                        {
                            List<?> list = new152();
                            push(goTo(15), list);
                        }
                        break;
                        case 153: /* reduce AAregexp1RegExp */
                        {
                            List<?> list = new153();
                            push(goTo(16), list);
                        }
                        break;
                        case 154: /* reduce AAregexp2RegExp */
                        {
                            List<?> list = new154();
                            push(goTo(16), list);
                        }
                        break;
                        case 155: /* reduce ARegExpTail */
                        {
                            List<?> list = new155();
                            push(goTo(17), list);
                        }
                        break;
                        case 156: /* reduce AAconcat1Concat */
                        {
                            List<?> list = new156();
                            push(goTo(18), list);
                        }
                        break;
                        case 157: /* reduce AAconcat2Concat */
                        {
                            List<?> list = new157();
                            push(goTo(18), list);
                        }
                        break;
                        case 158: /* reduce AAunexp1UnExp */
                        {
                            List<?> list = new158();
                            push(goTo(19), list);
                        }
                        break;
                        case 159: /* reduce AAunexp2UnExp */
                        {
                            List<?> list = new159();
                            push(goTo(19), list);
                        }
                        break;
                        case 160: /* reduce ACharBasic */
                        {
                            List<?> list = new160();
                            push(goTo(20), list);
                        }
                        break;
                        case 161: /* reduce ASetBasic */
                        {
                            List<?> list = new161();
                            push(goTo(20), list);
                        }
                        break;
                        case 162: /* reduce AStringBasic */
                        {
                            List<?> list = new162();
                            push(goTo(20), list);
                        }
                        break;
                        case 163: /* reduce AIdBasic */
                        {
                            List<?> list = new163();
                            push(goTo(20), list);
                        }
                        break;
                        case 164: /* reduce ARegExpBasic */
                        {
                            List<?> list = new164();
                            push(goTo(20), list);
                        }
                        break;
                        case 165: /* reduce ACharChar */
                        {
                            List<?> list = new165();
                            push(goTo(21), list);
                        }
                        break;
                        case 166: /* reduce ADecChar */
                        {
                            List<?> list = new166();
                            push(goTo(21), list);
                        }
                        break;
                        case 167: /* reduce AHexChar */
                        {
                            List<?> list = new167();
                            push(goTo(21), list);
                        }
                        break;
                        case 168: /* reduce AOperationSet */
                        {
                            List<?> list = new168();
                            push(goTo(22), list);
                        }
                        break;
                        case 169: /* reduce AIntervalSet */
                        {
                            List<?> list = new169();
                            push(goTo(22), list);
                        }
                        break;
                        case 170: /* reduce AStarUnOp */
                        {
                            List<?> list = new170();
                            push(goTo(23), list);
                        }
                        break;
                        case 171: /* reduce AQMarkUnOp */
                        {
                            List<?> list = new171();
                            push(goTo(23), list);
                        }
                        break;
                        case 172: /* reduce APlusUnOp */
                        {
                            List<?> list = new172();
                            push(goTo(23), list);
                        }
                        break;
                        case 173: /* reduce APlusBinOp */
                        {
                            List<?> list = new173();
                            push(goTo(24), list);
                        }
                        break;
                        case 174: /* reduce AMinusBinOp */
                        {
                            List<?> list = new174();
                            push(goTo(24), list);
                        }
                        break;
                        case 175: /* reduce AProductions */
                        {
                            List<?> list = new175();
                            push(goTo(25), list);
                        }
                        break;
                        case 176: /* reduce AAprod1Prod */
                        {
                            List<?> list = new176();
                            push(goTo(26), list);
                        }
                        break;
                        case 177: /* reduce AAprod2Prod */
                        {
                            List<?> list = new177();
                            push(goTo(26), list);
                        }
                        break;
                        case 178: /* reduce AAprodtransform1ProdTransform */
                        {
                            List<?> list = new178();
                            push(goTo(27), list);
                        }
                        break;
                        case 179: /* reduce AAprodtransform2ProdTransform */
                        {
                            List<?> list = new179();
                            push(goTo(27), list);
                        }
                        break;
                        case 180: /* reduce AAalts1Alts */
                        {
                            List<?> list = new180();
                            push(goTo(28), list);
                        }
                        break;
                        case 181: /* reduce AAalts2Alts */
                        {
                            List<?> list = new181();
                            push(goTo(28), list);
                        }
                        break;
                        case 182: /* reduce AAltsTail */
                        {
                            List<?> list = new182();
                            push(goTo(29), list);
                        }
                        break;
                        case 183: /* reduce AAalt1Alt */
                        {
                            List<?> list = new183();
                            push(goTo(30), list);
                        }
                        break;
                        case 184: /* reduce AAalt2Alt */
                        {
                            List<?> list = new184();
                            push(goTo(30), list);
                        }
                        break;
                        case 185: /* reduce AAalt3Alt */
                        {
                            List<?> list = new185();
                            push(goTo(30), list);
                        }
                        break;
                        case 186: /* reduce AAalt4Alt */
                        {
                            List<?> list = new186();
                            push(goTo(30), list);
                        }
                        break;
                        case 187: /* reduce AAalt5Alt */
                        {
                            List<?> list = new187();
                            push(goTo(30), list);
                        }
                        break;
                        case 188: /* reduce AAalt6Alt */
                        {
                            List<?> list = new188();
                            push(goTo(30), list);
                        }
                        break;
                        case 189: /* reduce AAalt7Alt */
                        {
                            List<?> list = new189();
                            push(goTo(30), list);
                        }
                        break;
                        case 190: /* reduce AAalt8Alt */
                        {
                            List<?> list = new190();
                            push(goTo(30), list);
                        }
                        break;
                        case 191: /* reduce AAalttransform1AltTransform */
                        {
                            List<?> list = new191();
                            push(goTo(31), list);
                        }
                        break;
                        case 192: /* reduce AAalttransform2AltTransform */
                        {
                            List<?> list = new192();
                            push(goTo(31), list);
                        }
                        break;
                        case 193: /* reduce AAnewterm1Term */
                        {
                            List<?> list = new193();
                            push(goTo(32), list);
                        }
                        break;
                        case 194: /* reduce AAnewterm2Term */
                        {
                            List<?> list = new194();
                            push(goTo(32), list);
                        }
                        break;
                        case 195: /* reduce AAlistterm1Term */
                        {
                            List<?> list = new195();
                            push(goTo(32), list);
                        }
                        break;
                        case 196: /* reduce AAlistterm2Term */
                        {
                            List<?> list = new196();
                            push(goTo(32), list);
                        }
                        break;
                        case 197: /* reduce AAsimpleterm1Term */
                        {
                            List<?> list = new197();
                            push(goTo(32), list);
                        }
                        break;
                        case 198: /* reduce AAsimpleterm2Term */
                        {
                            List<?> list = new198();
                            push(goTo(32), list);
                        }
                        break;
                        case 199: /* reduce AAsimpleterm3Term */
                        {
                            List<?> list = new199();
                            push(goTo(32), list);
                        }
                        break;
                        case 200: /* reduce AAsimpleterm4Term */
                        {
                            List<?> list = new200();
                            push(goTo(32), list);
                        }
                        break;
                        case 201: /* reduce ANullTerm */
                        {
                            List<?> list = new201();
                            push(goTo(32), list);
                        }
                        break;
                        case 202: /* reduce AAlistoflistterm1ListOfListTerm */
                        {
                            List<?> list = new202();
                            push(goTo(33), list);
                        }
                        break;
                        case 203: /* reduce AAlistoflistterm2ListOfListTerm */
                        {
                            List<?> list = new203();
                            push(goTo(33), list);
                        }
                        break;
                        case 204: /* reduce AAnewlistterm1ListTerm */
                        {
                            List<?> list = new204();
                            push(goTo(34), list);
                        }
                        break;
                        case 205: /* reduce AAnewlistterm2ListTerm */
                        {
                            List<?> list = new205();
                            push(goTo(34), list);
                        }
                        break;
                        case 206: /* reduce AAsimplelistterm1ListTerm */
                        {
                            List<?> list = new206();
                            push(goTo(34), list);
                        }
                        break;
                        case 207: /* reduce AAsimplelistterm2ListTerm */
                        {
                            List<?> list = new207();
                            push(goTo(34), list);
                        }
                        break;
                        case 208: /* reduce AAsimplelistterm3ListTerm */
                        {
                            List<?> list = new208();
                            push(goTo(34), list);
                        }
                        break;
                        case 209: /* reduce AAsimplelistterm4ListTerm */
                        {
                            List<?> list = new209();
                            push(goTo(34), list);
                        }
                        break;
                        case 210: /* reduce AListTermTail */
                        {
                            List<?> list = new210();
                            push(goTo(35), list);
                        }
                        break;
                        case 211: /* reduce ASimpleTermTail */
                        {
                            List<?> list = new211();
                            push(goTo(36), list);
                        }
                        break;
                        case 212: /* reduce AAprodname1ProdName */
                        {
                            List<?> list = new212();
                            push(goTo(37), list);
                        }
                        break;
                        case 213: /* reduce AAprodname2ProdName */
                        {
                            List<?> list = new213();
                            push(goTo(37), list);
                        }
                        break;
                        case 214: /* reduce AProdNameTail */
                        {
                            List<?> list = new214();
                            push(goTo(38), list);
                        }
                        break;
                        case 215: /* reduce AAparams1Params */
                        {
                            List<?> list = new215();
                            push(goTo(39), list);
                        }
                        break;
                        case 216: /* reduce AAparams2Params */
                        {
                            List<?> list = new216();
                            push(goTo(39), list);
                        }
                        break;
                        case 217: /* reduce AParamsTail */
                        {
                            List<?> list = new217();
                            push(goTo(40), list);
                        }
                        break;
                        case 218: /* reduce AAltName */
                        {
                            List<?> list = new218();
                            push(goTo(41), list);
                        }
                        break;
                        case 219: /* reduce AAelem1Elem */
                        {
                            List<?> list = new219();
                            push(goTo(42), list);
                        }
                        break;
                        case 220: /* reduce AAelem2Elem */
                        {
                            List<?> list = new220();
                            push(goTo(42), list);
                        }
                        break;
                        case 221: /* reduce AAelem3Elem */
                        {
                            List<?> list = new221();
                            push(goTo(42), list);
                        }
                        break;
                        case 222: /* reduce AAelem4Elem */
                        {
                            List<?> list = new222();
                            push(goTo(42), list);
                        }
                        break;
                        case 223: /* reduce AAelem5Elem */
                        {
                            List<?> list = new223();
                            push(goTo(42), list);
                        }
                        break;
                        case 224: /* reduce AAelem6Elem */
                        {
                            List<?> list = new224();
                            push(goTo(42), list);
                        }
                        break;
                        case 225: /* reduce AAelem7Elem */
                        {
                            List<?> list = new225();
                            push(goTo(42), list);
                        }
                        break;
                        case 226: /* reduce AAelem8Elem */
                        {
                            List<?> list = new226();
                            push(goTo(42), list);
                        }
                        break;
                        case 227: /* reduce AElemName */
                        {
                            List<?> list = new227();
                            push(goTo(43), list);
                        }
                        break;
                        case 228: /* reduce ATokenSpecifier */
                        {
                            List<?> list = new228();
                            push(goTo(44), list);
                        }
                        break;
                        case 229: /* reduce AProductionSpecifier */
                        {
                            List<?> list = new229();
                            push(goTo(44), list);
                        }
                        break;
                        case 230: /* reduce AAst */
                        {
                            List<?> list = new230();
                            push(goTo(45), list);
                        }
                        break;
                        case 231: /* reduce AAstProd */
                        {
                            List<?> list = new231();
                            push(goTo(46), list);
                        }
                        break;
                        case 232: /* reduce AAastalts1AstAlts */
                        {
                            List<?> list = new232();
                            push(goTo(47), list);
                        }
                        break;
                        case 233: /* reduce AAastalts2AstAlts */
                        {
                            List<?> list = new233();
                            push(goTo(47), list);
                        }
                        break;
                        case 234: /* reduce AAstAltsTail */
                        {
                            List<?> list = new234();
                            push(goTo(48), list);
                        }
                        break;
                        case 235: /* reduce AAastalt1AstAlt */
                        {
                            List<?> list = new235();
                            push(goTo(49), list);
                        }
                        break;
                        case 236: /* reduce AAastalt2AstAlt */
                        {
                            List<?> list = new236();
                            push(goTo(49), list);
                        }
                        break;
                        case 237: /* reduce AAastalt3AstAlt */
                        {
                            List<?> list = new237();
                            push(goTo(49), list);
                        }
                        break;
                        case 238: /* reduce AAastalt4AstAlt */
                        {
                            List<?> list = new238();
                            push(goTo(49), list);
                        }
                        break;
                        case 239: /* reduce ATerminal$PkgNameTail */
                        {
                            List<?> list = new239();
                            push(goTo(50), list);
                        }
                        break;
                        case 240: /* reduce ANonTerminal$PkgNameTail */
                        {
                            List<?> list = new240();
                            push(goTo(50), list);
                        }
                        break;
                        case 241: /* reduce ATerminal$HelperDef */
                        {
                            List<?> list = new241();
                            push(goTo(51), list);
                        }
                        break;
                        case 242: /* reduce ANonTerminal$HelperDef */
                        {
                            List<?> list = new242();
                            push(goTo(51), list);
                        }
                        break;
                        case 243: /* reduce ATerminal$IdListTail */
                        {
                            List<?> list = new243();
                            push(goTo(52), list);
                        }
                        break;
                        case 244: /* reduce ANonTerminal$IdListTail */
                        {
                            List<?> list = new244();
                            push(goTo(52), list);
                        }
                        break;
                        case 245: /* reduce ATerminal$TokenDef */
                        {
                            List<?> list = new245();
                            push(goTo(53), list);
                        }
                        break;
                        case 246: /* reduce ANonTerminal$TokenDef */
                        {
                            List<?> list = new246();
                            push(goTo(53), list);
                        }
                        break;
                        case 247: /* reduce ATerminal$StateListTail */
                        {
                            List<?> list = new247();
                            push(goTo(54), list);
                        }
                        break;
                        case 248: /* reduce ANonTerminal$StateListTail */
                        {
                            List<?> list = new248();
                            push(goTo(54), list);
                        }
                        break;
                        case 249: /* reduce ATerminal$RegExpTail */
                        {
                            List<?> list = new249();
                            push(goTo(55), list);
                        }
                        break;
                        case 250: /* reduce ANonTerminal$RegExpTail */
                        {
                            List<?> list = new250();
                            push(goTo(55), list);
                        }
                        break;
                        case 251: /* reduce ATerminal$UnExp */
                        {
                            List<?> list = new251();
                            push(goTo(56), list);
                        }
                        break;
                        case 252: /* reduce ANonTerminal$UnExp */
                        {
                            List<?> list = new252();
                            push(goTo(56), list);
                        }
                        break;
                        case 253: /* reduce ATerminal$Prod */
                        {
                            List<?> list = new253();
                            push(goTo(57), list);
                        }
                        break;
                        case 254: /* reduce ANonTerminal$Prod */
                        {
                            List<?> list = new254();
                            push(goTo(57), list);
                        }
                        break;
                        case 255: /* reduce ATerminal$Elem */
                        {
                            List<?> list = new255();
                            push(goTo(58), list);
                        }
                        break;
                        case 256: /* reduce ANonTerminal$Elem */
                        {
                            List<?> list = new256();
                            push(goTo(58), list);
                        }
                        break;
                        case 257: /* reduce ATerminal$AltsTail */
                        {
                            List<?> list = new257();
                            push(goTo(59), list);
                        }
                        break;
                        case 258: /* reduce ANonTerminal$AltsTail */
                        {
                            List<?> list = new258();
                            push(goTo(59), list);
                        }
                        break;
                        case 259: /* reduce ATerminal$Term */
                        {
                            List<?> list = new259();
                            push(goTo(60), list);
                        }
                        break;
                        case 260: /* reduce ANonTerminal$Term */
                        {
                            List<?> list = new260();
                            push(goTo(60), list);
                        }
                        break;
                        case 261: /* reduce ATerminal$ListTermTail */
                        {
                            List<?> list = new261();
                            push(goTo(61), list);
                        }
                        break;
                        case 262: /* reduce ANonTerminal$ListTermTail */
                        {
                            List<?> list = new262();
                            push(goTo(61), list);
                        }
                        break;
                        case 263: /* reduce ATerminal$ParamsTail */
                        {
                            List<?> list = new263();
                            push(goTo(62), list);
                        }
                        break;
                        case 264: /* reduce ANonTerminal$ParamsTail */
                        {
                            List<?> list = new264();
                            push(goTo(62), list);
                        }
                        break;
                        case 265: /* reduce ATerminal$AstProd */
                        {
                            List<?> list = new265();
                            push(goTo(63), list);
                        }
                        break;
                        case 266: /* reduce ANonTerminal$AstProd */
                        {
                            List<?> list = new266();
                            push(goTo(63), list);
                        }
                        break;
                        case 267: /* reduce ATerminal$AstAltsTail */
                        {
                            List<?> list = new267();
                            push(goTo(64), list);
                        }
                        break;
                        case 268: /* reduce ANonTerminal$AstAltsTail */
                        {
                            List<?> list = new268();
                            push(goTo(64), list);
                        }
                        break;
                        default:
                            throw new ParserException(lastToken, "[" + lastToken.getLine() + "," + lastToken.getPos() + "] Internal parser error: invalid action table REDUCE destination " + destination + ", current state " + state());
                    }
                    break;

                case ACCEPT:
                    EOF eof = (EOF) this.lexer.next();
                    PGrammar top = (PGrammar) pop().get(0);
                    return new Start(top, eof);

                case ERROR:
                    throw new ParserException(lastToken,
                        "[" + lastToken.getLine() + "," + lastToken.getPos() + "] " ,
                        Parser.errorMessages[Parser.errors[destination]]);

                default:
                    throw new ParserException(lastToken, "[" + lastToken.getLine() + "," + lastToken.getPos() + "] Internal parser error: invalid action table entry " + action + ", destination " + destination + ", current state " + state());
            }
        }
    }


    private List<?> new0() /* reduce AAgrammar1Grammar */
    {

        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), null, null, null, null, null, null);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new1() /* reduce AAgrammar2Grammar */
    {
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        AGrammar pGrammarNode1 = new AGrammar(listNode3, null, null, null, null, null, null);
        computePositions(pGrammarNode1, popped1, popped1);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new2() /* reduce AAgrammar3Grammar */
    {
        List<?> popped1 = pop();

        PHelpers pHelpersNode3 = (PHelpers)popped1.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), pHelpersNode3, null, null, null, null, null);
        computePositions(pGrammarNode1, popped1, popped1);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new3() /* reduce AAgrammar4Grammar */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PHelpers pHelpersNode4 = (PHelpers)popped2.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, pHelpersNode4, null, null, null, null, null);
        computePositions(pGrammarNode1, popped1, popped2);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new4() /* reduce AAgrammar5Grammar */
    {
        List<?> popped1 = pop();

        PStates pStatesNode4 = (PStates)popped1.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), null, pStatesNode4, null, null, null, null);
        computePositions(pGrammarNode1, popped1, popped1);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new5() /* reduce AAgrammar6Grammar */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PStates pStatesNode5 = (PStates)popped2.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, null, pStatesNode5, null, null, null, null);
        computePositions(pGrammarNode1, popped1, popped2);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new6() /* reduce AAgrammar7Grammar */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PHelpers pHelpersNode3 = (PHelpers)popped1.get(0);
        PStates pStatesNode4 = (PStates)popped2.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), pHelpersNode3, pStatesNode4, null, null, null, null);
        computePositions(pGrammarNode1, popped1, popped2);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new7() /* reduce AAgrammar8Grammar */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PHelpers pHelpersNode4 = (PHelpers)popped2.get(0);
        PStates pStatesNode5 = (PStates)popped3.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, pHelpersNode4, pStatesNode5, null, null, null, null);
        computePositions(pGrammarNode1, popped1, popped3);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new8() /* reduce AAgrammar9Grammar */
    {
        List<?> popped1 = pop();

        PTokens pTokensNode5 = (PTokens)popped1.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), null, null, pTokensNode5, null, null, null);
        computePositions(pGrammarNode1, popped1, popped1);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new9() /* reduce AAgrammar10Grammar */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PTokens pTokensNode6 = (PTokens)popped2.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, null, null, pTokensNode6, null, null, null);
        computePositions(pGrammarNode1, popped1, popped2);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new10() /* reduce AAgrammar11Grammar */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PHelpers pHelpersNode3 = (PHelpers)popped1.get(0);
        PTokens pTokensNode5 = (PTokens)popped2.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), pHelpersNode3, null, pTokensNode5, null, null, null);
        computePositions(pGrammarNode1, popped1, popped2);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new11() /* reduce AAgrammar12Grammar */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PHelpers pHelpersNode4 = (PHelpers)popped2.get(0);
        PTokens pTokensNode6 = (PTokens)popped3.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, pHelpersNode4, null, pTokensNode6, null, null, null);
        computePositions(pGrammarNode1, popped1, popped3);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new12() /* reduce AAgrammar13Grammar */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PStates pStatesNode4 = (PStates)popped1.get(0);
        PTokens pTokensNode5 = (PTokens)popped2.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), null, pStatesNode4, pTokensNode5, null, null, null);
        computePositions(pGrammarNode1, popped1, popped2);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new13() /* reduce AAgrammar14Grammar */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PStates pStatesNode5 = (PStates)popped2.get(0);
        PTokens pTokensNode6 = (PTokens)popped3.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, null, pStatesNode5, pTokensNode6, null, null, null);
        computePositions(pGrammarNode1, popped1, popped3);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new14() /* reduce AAgrammar15Grammar */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PHelpers pHelpersNode3 = (PHelpers)popped1.get(0);
        PStates pStatesNode4 = (PStates)popped2.get(0);
        PTokens pTokensNode5 = (PTokens)popped3.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), pHelpersNode3, pStatesNode4, pTokensNode5, null, null, null);
        computePositions(pGrammarNode1, popped1, popped3);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new15() /* reduce AAgrammar16Grammar */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PHelpers pHelpersNode4 = (PHelpers)popped2.get(0);
        PStates pStatesNode5 = (PStates)popped3.get(0);
        PTokens pTokensNode6 = (PTokens)popped4.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, pHelpersNode4, pStatesNode5, pTokensNode6, null, null, null);
        computePositions(pGrammarNode1, popped1, popped4);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new16() /* reduce AAgrammar17Grammar */
    {
        List<?> popped1 = pop();

        PIgnTokens pIgnTokensNode6 = (PIgnTokens)popped1.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), null, null, null, pIgnTokensNode6, null, null);
        computePositions(pGrammarNode1, popped1, popped1);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new17() /* reduce AAgrammar18Grammar */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PIgnTokens pIgnTokensNode7 = (PIgnTokens)popped2.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, null, null, null, pIgnTokensNode7, null, null);
        computePositions(pGrammarNode1, popped1, popped2);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new18() /* reduce AAgrammar19Grammar */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PHelpers pHelpersNode3 = (PHelpers)popped1.get(0);
        PIgnTokens pIgnTokensNode6 = (PIgnTokens)popped2.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), pHelpersNode3, null, null, pIgnTokensNode6, null, null);
        computePositions(pGrammarNode1, popped1, popped2);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new19() /* reduce AAgrammar20Grammar */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PHelpers pHelpersNode4 = (PHelpers)popped2.get(0);
        PIgnTokens pIgnTokensNode7 = (PIgnTokens)popped3.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, pHelpersNode4, null, null, pIgnTokensNode7, null, null);
        computePositions(pGrammarNode1, popped1, popped3);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new20() /* reduce AAgrammar21Grammar */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PStates pStatesNode4 = (PStates)popped1.get(0);
        PIgnTokens pIgnTokensNode6 = (PIgnTokens)popped2.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), null, pStatesNode4, null, pIgnTokensNode6, null, null);
        computePositions(pGrammarNode1, popped1, popped2);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new21() /* reduce AAgrammar22Grammar */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PStates pStatesNode5 = (PStates)popped2.get(0);
        PIgnTokens pIgnTokensNode7 = (PIgnTokens)popped3.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, null, pStatesNode5, null, pIgnTokensNode7, null, null);
        computePositions(pGrammarNode1, popped1, popped3);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new22() /* reduce AAgrammar23Grammar */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PHelpers pHelpersNode3 = (PHelpers)popped1.get(0);
        PStates pStatesNode4 = (PStates)popped2.get(0);
        PIgnTokens pIgnTokensNode6 = (PIgnTokens)popped3.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), pHelpersNode3, pStatesNode4, null, pIgnTokensNode6, null, null);
        computePositions(pGrammarNode1, popped1, popped3);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new23() /* reduce AAgrammar24Grammar */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PHelpers pHelpersNode4 = (PHelpers)popped2.get(0);
        PStates pStatesNode5 = (PStates)popped3.get(0);
        PIgnTokens pIgnTokensNode7 = (PIgnTokens)popped4.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, pHelpersNode4, pStatesNode5, null, pIgnTokensNode7, null, null);
        computePositions(pGrammarNode1, popped1, popped4);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new24() /* reduce AAgrammar25Grammar */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PTokens pTokensNode5 = (PTokens)popped1.get(0);
        PIgnTokens pIgnTokensNode6 = (PIgnTokens)popped2.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), null, null, pTokensNode5, pIgnTokensNode6, null, null);
        computePositions(pGrammarNode1, popped1, popped2);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new25() /* reduce AAgrammar26Grammar */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PTokens pTokensNode6 = (PTokens)popped2.get(0);
        PIgnTokens pIgnTokensNode7 = (PIgnTokens)popped3.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, null, null, pTokensNode6, pIgnTokensNode7, null, null);
        computePositions(pGrammarNode1, popped1, popped3);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new26() /* reduce AAgrammar27Grammar */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PHelpers pHelpersNode3 = (PHelpers)popped1.get(0);
        PTokens pTokensNode5 = (PTokens)popped2.get(0);
        PIgnTokens pIgnTokensNode6 = (PIgnTokens)popped3.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), pHelpersNode3, null, pTokensNode5, pIgnTokensNode6, null, null);
        computePositions(pGrammarNode1, popped1, popped3);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new27() /* reduce AAgrammar28Grammar */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PHelpers pHelpersNode4 = (PHelpers)popped2.get(0);
        PTokens pTokensNode6 = (PTokens)popped3.get(0);
        PIgnTokens pIgnTokensNode7 = (PIgnTokens)popped4.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, pHelpersNode4, null, pTokensNode6, pIgnTokensNode7, null, null);
        computePositions(pGrammarNode1, popped1, popped4);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new28() /* reduce AAgrammar29Grammar */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PStates pStatesNode4 = (PStates)popped1.get(0);
        PTokens pTokensNode5 = (PTokens)popped2.get(0);
        PIgnTokens pIgnTokensNode6 = (PIgnTokens)popped3.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), null, pStatesNode4, pTokensNode5, pIgnTokensNode6, null, null);
        computePositions(pGrammarNode1, popped1, popped3);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new29() /* reduce AAgrammar30Grammar */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PStates pStatesNode5 = (PStates)popped2.get(0);
        PTokens pTokensNode6 = (PTokens)popped3.get(0);
        PIgnTokens pIgnTokensNode7 = (PIgnTokens)popped4.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, null, pStatesNode5, pTokensNode6, pIgnTokensNode7, null, null);
        computePositions(pGrammarNode1, popped1, popped4);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new30() /* reduce AAgrammar31Grammar */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PHelpers pHelpersNode3 = (PHelpers)popped1.get(0);
        PStates pStatesNode4 = (PStates)popped2.get(0);
        PTokens pTokensNode5 = (PTokens)popped3.get(0);
        PIgnTokens pIgnTokensNode6 = (PIgnTokens)popped4.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), pHelpersNode3, pStatesNode4, pTokensNode5, pIgnTokensNode6, null, null);
        computePositions(pGrammarNode1, popped1, popped4);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new31() /* reduce AAgrammar32Grammar */
    {
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PHelpers pHelpersNode4 = (PHelpers)popped2.get(0);
        PStates pStatesNode5 = (PStates)popped3.get(0);
        PTokens pTokensNode6 = (PTokens)popped4.get(0);
        PIgnTokens pIgnTokensNode7 = (PIgnTokens)popped5.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, pHelpersNode4, pStatesNode5, pTokensNode6, pIgnTokensNode7, null, null);
        computePositions(pGrammarNode1, popped1, popped5);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new32() /* reduce AAgrammar33Grammar */
    {
        List<?> popped1 = pop();

        PProductions pProductionsNode7 = (PProductions)popped1.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), null, null, null, null, pProductionsNode7, null);
        computePositions(pGrammarNode1, popped1, popped1);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new33() /* reduce AAgrammar34Grammar */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PProductions pProductionsNode8 = (PProductions)popped2.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, null, null, null, null, pProductionsNode8, null);
        computePositions(pGrammarNode1, popped1, popped2);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new34() /* reduce AAgrammar35Grammar */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PHelpers pHelpersNode3 = (PHelpers)popped1.get(0);
        PProductions pProductionsNode7 = (PProductions)popped2.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), pHelpersNode3, null, null, null, pProductionsNode7, null);
        computePositions(pGrammarNode1, popped1, popped2);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new35() /* reduce AAgrammar36Grammar */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PHelpers pHelpersNode4 = (PHelpers)popped2.get(0);
        PProductions pProductionsNode8 = (PProductions)popped3.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, pHelpersNode4, null, null, null, pProductionsNode8, null);
        computePositions(pGrammarNode1, popped1, popped3);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new36() /* reduce AAgrammar37Grammar */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PStates pStatesNode4 = (PStates)popped1.get(0);
        PProductions pProductionsNode7 = (PProductions)popped2.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), null, pStatesNode4, null, null, pProductionsNode7, null);
        computePositions(pGrammarNode1, popped1, popped2);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new37() /* reduce AAgrammar38Grammar */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PStates pStatesNode5 = (PStates)popped2.get(0);
        PProductions pProductionsNode8 = (PProductions)popped3.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, null, pStatesNode5, null, null, pProductionsNode8, null);
        computePositions(pGrammarNode1, popped1, popped3);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new38() /* reduce AAgrammar39Grammar */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PHelpers pHelpersNode3 = (PHelpers)popped1.get(0);
        PStates pStatesNode4 = (PStates)popped2.get(0);
        PProductions pProductionsNode7 = (PProductions)popped3.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), pHelpersNode3, pStatesNode4, null, null, pProductionsNode7, null);
        computePositions(pGrammarNode1, popped1, popped3);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new39() /* reduce AAgrammar40Grammar */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PHelpers pHelpersNode4 = (PHelpers)popped2.get(0);
        PStates pStatesNode5 = (PStates)popped3.get(0);
        PProductions pProductionsNode8 = (PProductions)popped4.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, pHelpersNode4, pStatesNode5, null, null, pProductionsNode8, null);
        computePositions(pGrammarNode1, popped1, popped4);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new40() /* reduce AAgrammar41Grammar */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PTokens pTokensNode5 = (PTokens)popped1.get(0);
        PProductions pProductionsNode7 = (PProductions)popped2.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), null, null, pTokensNode5, null, pProductionsNode7, null);
        computePositions(pGrammarNode1, popped1, popped2);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new41() /* reduce AAgrammar42Grammar */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PTokens pTokensNode6 = (PTokens)popped2.get(0);
        PProductions pProductionsNode8 = (PProductions)popped3.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, null, null, pTokensNode6, null, pProductionsNode8, null);
        computePositions(pGrammarNode1, popped1, popped3);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new42() /* reduce AAgrammar43Grammar */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PHelpers pHelpersNode3 = (PHelpers)popped1.get(0);
        PTokens pTokensNode5 = (PTokens)popped2.get(0);
        PProductions pProductionsNode7 = (PProductions)popped3.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), pHelpersNode3, null, pTokensNode5, null, pProductionsNode7, null);
        computePositions(pGrammarNode1, popped1, popped3);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new43() /* reduce AAgrammar44Grammar */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PHelpers pHelpersNode4 = (PHelpers)popped2.get(0);
        PTokens pTokensNode6 = (PTokens)popped3.get(0);
        PProductions pProductionsNode8 = (PProductions)popped4.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, pHelpersNode4, null, pTokensNode6, null, pProductionsNode8, null);
        computePositions(pGrammarNode1, popped1, popped4);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new44() /* reduce AAgrammar45Grammar */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PStates pStatesNode4 = (PStates)popped1.get(0);
        PTokens pTokensNode5 = (PTokens)popped2.get(0);
        PProductions pProductionsNode7 = (PProductions)popped3.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), null, pStatesNode4, pTokensNode5, null, pProductionsNode7, null);
        computePositions(pGrammarNode1, popped1, popped3);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new45() /* reduce AAgrammar46Grammar */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PStates pStatesNode5 = (PStates)popped2.get(0);
        PTokens pTokensNode6 = (PTokens)popped3.get(0);
        PProductions pProductionsNode8 = (PProductions)popped4.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, null, pStatesNode5, pTokensNode6, null, pProductionsNode8, null);
        computePositions(pGrammarNode1, popped1, popped4);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new46() /* reduce AAgrammar47Grammar */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PHelpers pHelpersNode3 = (PHelpers)popped1.get(0);
        PStates pStatesNode4 = (PStates)popped2.get(0);
        PTokens pTokensNode5 = (PTokens)popped3.get(0);
        PProductions pProductionsNode7 = (PProductions)popped4.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), pHelpersNode3, pStatesNode4, pTokensNode5, null, pProductionsNode7, null);
        computePositions(pGrammarNode1, popped1, popped4);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new47() /* reduce AAgrammar48Grammar */
    {
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PHelpers pHelpersNode4 = (PHelpers)popped2.get(0);
        PStates pStatesNode5 = (PStates)popped3.get(0);
        PTokens pTokensNode6 = (PTokens)popped4.get(0);
        PProductions pProductionsNode8 = (PProductions)popped5.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, pHelpersNode4, pStatesNode5, pTokensNode6, null, pProductionsNode8, null);
        computePositions(pGrammarNode1, popped1, popped5);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new48() /* reduce AAgrammar49Grammar */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PIgnTokens pIgnTokensNode6 = (PIgnTokens)popped1.get(0);
        PProductions pProductionsNode7 = (PProductions)popped2.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), null, null, null, pIgnTokensNode6, pProductionsNode7, null);
        computePositions(pGrammarNode1, popped1, popped2);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new49() /* reduce AAgrammar50Grammar */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PIgnTokens pIgnTokensNode7 = (PIgnTokens)popped2.get(0);
        PProductions pProductionsNode8 = (PProductions)popped3.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, null, null, null, pIgnTokensNode7, pProductionsNode8, null);
        computePositions(pGrammarNode1, popped1, popped3);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new50() /* reduce AAgrammar51Grammar */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PHelpers pHelpersNode3 = (PHelpers)popped1.get(0);
        PIgnTokens pIgnTokensNode6 = (PIgnTokens)popped2.get(0);
        PProductions pProductionsNode7 = (PProductions)popped3.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), pHelpersNode3, null, null, pIgnTokensNode6, pProductionsNode7, null);
        computePositions(pGrammarNode1, popped1, popped3);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new51() /* reduce AAgrammar52Grammar */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PHelpers pHelpersNode4 = (PHelpers)popped2.get(0);
        PIgnTokens pIgnTokensNode7 = (PIgnTokens)popped3.get(0);
        PProductions pProductionsNode8 = (PProductions)popped4.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, pHelpersNode4, null, null, pIgnTokensNode7, pProductionsNode8, null);
        computePositions(pGrammarNode1, popped1, popped4);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new52() /* reduce AAgrammar53Grammar */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PStates pStatesNode4 = (PStates)popped1.get(0);
        PIgnTokens pIgnTokensNode6 = (PIgnTokens)popped2.get(0);
        PProductions pProductionsNode7 = (PProductions)popped3.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), null, pStatesNode4, null, pIgnTokensNode6, pProductionsNode7, null);
        computePositions(pGrammarNode1, popped1, popped3);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new53() /* reduce AAgrammar54Grammar */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PStates pStatesNode5 = (PStates)popped2.get(0);
        PIgnTokens pIgnTokensNode7 = (PIgnTokens)popped3.get(0);
        PProductions pProductionsNode8 = (PProductions)popped4.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, null, pStatesNode5, null, pIgnTokensNode7, pProductionsNode8, null);
        computePositions(pGrammarNode1, popped1, popped4);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new54() /* reduce AAgrammar55Grammar */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PHelpers pHelpersNode3 = (PHelpers)popped1.get(0);
        PStates pStatesNode4 = (PStates)popped2.get(0);
        PIgnTokens pIgnTokensNode6 = (PIgnTokens)popped3.get(0);
        PProductions pProductionsNode7 = (PProductions)popped4.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), pHelpersNode3, pStatesNode4, null, pIgnTokensNode6, pProductionsNode7, null);
        computePositions(pGrammarNode1, popped1, popped4);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new55() /* reduce AAgrammar56Grammar */
    {
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PHelpers pHelpersNode4 = (PHelpers)popped2.get(0);
        PStates pStatesNode5 = (PStates)popped3.get(0);
        PIgnTokens pIgnTokensNode7 = (PIgnTokens)popped4.get(0);
        PProductions pProductionsNode8 = (PProductions)popped5.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, pHelpersNode4, pStatesNode5, null, pIgnTokensNode7, pProductionsNode8, null);
        computePositions(pGrammarNode1, popped1, popped5);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new56() /* reduce AAgrammar57Grammar */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PTokens pTokensNode5 = (PTokens)popped1.get(0);
        PIgnTokens pIgnTokensNode6 = (PIgnTokens)popped2.get(0);
        PProductions pProductionsNode7 = (PProductions)popped3.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), null, null, pTokensNode5, pIgnTokensNode6, pProductionsNode7, null);
        computePositions(pGrammarNode1, popped1, popped3);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new57() /* reduce AAgrammar58Grammar */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PTokens pTokensNode6 = (PTokens)popped2.get(0);
        PIgnTokens pIgnTokensNode7 = (PIgnTokens)popped3.get(0);
        PProductions pProductionsNode8 = (PProductions)popped4.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, null, null, pTokensNode6, pIgnTokensNode7, pProductionsNode8, null);
        computePositions(pGrammarNode1, popped1, popped4);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new58() /* reduce AAgrammar59Grammar */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PHelpers pHelpersNode3 = (PHelpers)popped1.get(0);
        PTokens pTokensNode5 = (PTokens)popped2.get(0);
        PIgnTokens pIgnTokensNode6 = (PIgnTokens)popped3.get(0);
        PProductions pProductionsNode7 = (PProductions)popped4.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), pHelpersNode3, null, pTokensNode5, pIgnTokensNode6, pProductionsNode7, null);
        computePositions(pGrammarNode1, popped1, popped4);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new59() /* reduce AAgrammar60Grammar */
    {
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PHelpers pHelpersNode4 = (PHelpers)popped2.get(0);
        PTokens pTokensNode6 = (PTokens)popped3.get(0);
        PIgnTokens pIgnTokensNode7 = (PIgnTokens)popped4.get(0);
        PProductions pProductionsNode8 = (PProductions)popped5.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, pHelpersNode4, null, pTokensNode6, pIgnTokensNode7, pProductionsNode8, null);
        computePositions(pGrammarNode1, popped1, popped5);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new60() /* reduce AAgrammar61Grammar */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PStates pStatesNode4 = (PStates)popped1.get(0);
        PTokens pTokensNode5 = (PTokens)popped2.get(0);
        PIgnTokens pIgnTokensNode6 = (PIgnTokens)popped3.get(0);
        PProductions pProductionsNode7 = (PProductions)popped4.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), null, pStatesNode4, pTokensNode5, pIgnTokensNode6, pProductionsNode7, null);
        computePositions(pGrammarNode1, popped1, popped4);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new61() /* reduce AAgrammar62Grammar */
    {
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PStates pStatesNode5 = (PStates)popped2.get(0);
        PTokens pTokensNode6 = (PTokens)popped3.get(0);
        PIgnTokens pIgnTokensNode7 = (PIgnTokens)popped4.get(0);
        PProductions pProductionsNode8 = (PProductions)popped5.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, null, pStatesNode5, pTokensNode6, pIgnTokensNode7, pProductionsNode8, null);
        computePositions(pGrammarNode1, popped1, popped5);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new62() /* reduce AAgrammar63Grammar */
    {
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PHelpers pHelpersNode3 = (PHelpers)popped1.get(0);
        PStates pStatesNode4 = (PStates)popped2.get(0);
        PTokens pTokensNode5 = (PTokens)popped3.get(0);
        PIgnTokens pIgnTokensNode6 = (PIgnTokens)popped4.get(0);
        PProductions pProductionsNode7 = (PProductions)popped5.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), pHelpersNode3, pStatesNode4, pTokensNode5, pIgnTokensNode6, pProductionsNode7, null);
        computePositions(pGrammarNode1, popped1, popped5);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new63() /* reduce AAgrammar64Grammar */
    {
        List<?> popped6 = pop();
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PHelpers pHelpersNode4 = (PHelpers)popped2.get(0);
        PStates pStatesNode5 = (PStates)popped3.get(0);
        PTokens pTokensNode6 = (PTokens)popped4.get(0);
        PIgnTokens pIgnTokensNode7 = (PIgnTokens)popped5.get(0);
        PProductions pProductionsNode8 = (PProductions)popped6.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, pHelpersNode4, pStatesNode5, pTokensNode6, pIgnTokensNode7, pProductionsNode8, null);
        computePositions(pGrammarNode1, popped1, popped6);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new64() /* reduce AAgrammar65Grammar */
    {
        List<?> popped1 = pop();

        PAst pAstNode8 = (PAst)popped1.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), null, null, null, null, null, pAstNode8);
        computePositions(pGrammarNode1, popped1, popped1);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new65() /* reduce AAgrammar66Grammar */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PAst pAstNode9 = (PAst)popped2.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, null, null, null, null, null, pAstNode9);
        computePositions(pGrammarNode1, popped1, popped2);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new66() /* reduce AAgrammar67Grammar */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PHelpers pHelpersNode3 = (PHelpers)popped1.get(0);
        PAst pAstNode8 = (PAst)popped2.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), pHelpersNode3, null, null, null, null, pAstNode8);
        computePositions(pGrammarNode1, popped1, popped2);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new67() /* reduce AAgrammar68Grammar */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PHelpers pHelpersNode4 = (PHelpers)popped2.get(0);
        PAst pAstNode9 = (PAst)popped3.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, pHelpersNode4, null, null, null, null, pAstNode9);
        computePositions(pGrammarNode1, popped1, popped3);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new68() /* reduce AAgrammar69Grammar */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PStates pStatesNode4 = (PStates)popped1.get(0);
        PAst pAstNode8 = (PAst)popped2.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), null, pStatesNode4, null, null, null, pAstNode8);
        computePositions(pGrammarNode1, popped1, popped2);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new69() /* reduce AAgrammar70Grammar */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PStates pStatesNode5 = (PStates)popped2.get(0);
        PAst pAstNode9 = (PAst)popped3.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, null, pStatesNode5, null, null, null, pAstNode9);
        computePositions(pGrammarNode1, popped1, popped3);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new70() /* reduce AAgrammar71Grammar */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PHelpers pHelpersNode3 = (PHelpers)popped1.get(0);
        PStates pStatesNode4 = (PStates)popped2.get(0);
        PAst pAstNode8 = (PAst)popped3.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), pHelpersNode3, pStatesNode4, null, null, null, pAstNode8);
        computePositions(pGrammarNode1, popped1, popped3);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new71() /* reduce AAgrammar72Grammar */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PHelpers pHelpersNode4 = (PHelpers)popped2.get(0);
        PStates pStatesNode5 = (PStates)popped3.get(0);
        PAst pAstNode9 = (PAst)popped4.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, pHelpersNode4, pStatesNode5, null, null, null, pAstNode9);
        computePositions(pGrammarNode1, popped1, popped4);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new72() /* reduce AAgrammar73Grammar */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PTokens pTokensNode5 = (PTokens)popped1.get(0);
        PAst pAstNode8 = (PAst)popped2.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), null, null, pTokensNode5, null, null, pAstNode8);
        computePositions(pGrammarNode1, popped1, popped2);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new73() /* reduce AAgrammar74Grammar */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PTokens pTokensNode6 = (PTokens)popped2.get(0);
        PAst pAstNode9 = (PAst)popped3.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, null, null, pTokensNode6, null, null, pAstNode9);
        computePositions(pGrammarNode1, popped1, popped3);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new74() /* reduce AAgrammar75Grammar */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PHelpers pHelpersNode3 = (PHelpers)popped1.get(0);
        PTokens pTokensNode5 = (PTokens)popped2.get(0);
        PAst pAstNode8 = (PAst)popped3.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), pHelpersNode3, null, pTokensNode5, null, null, pAstNode8);
        computePositions(pGrammarNode1, popped1, popped3);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new75() /* reduce AAgrammar76Grammar */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PHelpers pHelpersNode4 = (PHelpers)popped2.get(0);
        PTokens pTokensNode6 = (PTokens)popped3.get(0);
        PAst pAstNode9 = (PAst)popped4.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, pHelpersNode4, null, pTokensNode6, null, null, pAstNode9);
        computePositions(pGrammarNode1, popped1, popped4);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new76() /* reduce AAgrammar77Grammar */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PStates pStatesNode4 = (PStates)popped1.get(0);
        PTokens pTokensNode5 = (PTokens)popped2.get(0);
        PAst pAstNode8 = (PAst)popped3.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), null, pStatesNode4, pTokensNode5, null, null, pAstNode8);
        computePositions(pGrammarNode1, popped1, popped3);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new77() /* reduce AAgrammar78Grammar */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PStates pStatesNode5 = (PStates)popped2.get(0);
        PTokens pTokensNode6 = (PTokens)popped3.get(0);
        PAst pAstNode9 = (PAst)popped4.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, null, pStatesNode5, pTokensNode6, null, null, pAstNode9);
        computePositions(pGrammarNode1, popped1, popped4);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new78() /* reduce AAgrammar79Grammar */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PHelpers pHelpersNode3 = (PHelpers)popped1.get(0);
        PStates pStatesNode4 = (PStates)popped2.get(0);
        PTokens pTokensNode5 = (PTokens)popped3.get(0);
        PAst pAstNode8 = (PAst)popped4.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), pHelpersNode3, pStatesNode4, pTokensNode5, null, null, pAstNode8);
        computePositions(pGrammarNode1, popped1, popped4);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new79() /* reduce AAgrammar80Grammar */
    {
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PHelpers pHelpersNode4 = (PHelpers)popped2.get(0);
        PStates pStatesNode5 = (PStates)popped3.get(0);
        PTokens pTokensNode6 = (PTokens)popped4.get(0);
        PAst pAstNode9 = (PAst)popped5.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, pHelpersNode4, pStatesNode5, pTokensNode6, null, null, pAstNode9);
        computePositions(pGrammarNode1, popped1, popped5);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new80() /* reduce AAgrammar81Grammar */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PIgnTokens pIgnTokensNode6 = (PIgnTokens)popped1.get(0);
        PAst pAstNode8 = (PAst)popped2.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), null, null, null, pIgnTokensNode6, null, pAstNode8);
        computePositions(pGrammarNode1, popped1, popped2);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new81() /* reduce AAgrammar82Grammar */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PIgnTokens pIgnTokensNode7 = (PIgnTokens)popped2.get(0);
        PAst pAstNode9 = (PAst)popped3.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, null, null, null, pIgnTokensNode7, null, pAstNode9);
        computePositions(pGrammarNode1, popped1, popped3);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new82() /* reduce AAgrammar83Grammar */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PHelpers pHelpersNode3 = (PHelpers)popped1.get(0);
        PIgnTokens pIgnTokensNode6 = (PIgnTokens)popped2.get(0);
        PAst pAstNode8 = (PAst)popped3.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), pHelpersNode3, null, null, pIgnTokensNode6, null, pAstNode8);
        computePositions(pGrammarNode1, popped1, popped3);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new83() /* reduce AAgrammar84Grammar */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PHelpers pHelpersNode4 = (PHelpers)popped2.get(0);
        PIgnTokens pIgnTokensNode7 = (PIgnTokens)popped3.get(0);
        PAst pAstNode9 = (PAst)popped4.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, pHelpersNode4, null, null, pIgnTokensNode7, null, pAstNode9);
        computePositions(pGrammarNode1, popped1, popped4);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new84() /* reduce AAgrammar85Grammar */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PStates pStatesNode4 = (PStates)popped1.get(0);
        PIgnTokens pIgnTokensNode6 = (PIgnTokens)popped2.get(0);
        PAst pAstNode8 = (PAst)popped3.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), null, pStatesNode4, null, pIgnTokensNode6, null, pAstNode8);
        computePositions(pGrammarNode1, popped1, popped3);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new85() /* reduce AAgrammar86Grammar */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PStates pStatesNode5 = (PStates)popped2.get(0);
        PIgnTokens pIgnTokensNode7 = (PIgnTokens)popped3.get(0);
        PAst pAstNode9 = (PAst)popped4.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, null, pStatesNode5, null, pIgnTokensNode7, null, pAstNode9);
        computePositions(pGrammarNode1, popped1, popped4);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new86() /* reduce AAgrammar87Grammar */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PHelpers pHelpersNode3 = (PHelpers)popped1.get(0);
        PStates pStatesNode4 = (PStates)popped2.get(0);
        PIgnTokens pIgnTokensNode6 = (PIgnTokens)popped3.get(0);
        PAst pAstNode8 = (PAst)popped4.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), pHelpersNode3, pStatesNode4, null, pIgnTokensNode6, null, pAstNode8);
        computePositions(pGrammarNode1, popped1, popped4);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new87() /* reduce AAgrammar88Grammar */
    {
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PHelpers pHelpersNode4 = (PHelpers)popped2.get(0);
        PStates pStatesNode5 = (PStates)popped3.get(0);
        PIgnTokens pIgnTokensNode7 = (PIgnTokens)popped4.get(0);
        PAst pAstNode9 = (PAst)popped5.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, pHelpersNode4, pStatesNode5, null, pIgnTokensNode7, null, pAstNode9);
        computePositions(pGrammarNode1, popped1, popped5);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new88() /* reduce AAgrammar89Grammar */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PTokens pTokensNode5 = (PTokens)popped1.get(0);
        PIgnTokens pIgnTokensNode6 = (PIgnTokens)popped2.get(0);
        PAst pAstNode8 = (PAst)popped3.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), null, null, pTokensNode5, pIgnTokensNode6, null, pAstNode8);
        computePositions(pGrammarNode1, popped1, popped3);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new89() /* reduce AAgrammar90Grammar */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PTokens pTokensNode6 = (PTokens)popped2.get(0);
        PIgnTokens pIgnTokensNode7 = (PIgnTokens)popped3.get(0);
        PAst pAstNode9 = (PAst)popped4.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, null, null, pTokensNode6, pIgnTokensNode7, null, pAstNode9);
        computePositions(pGrammarNode1, popped1, popped4);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new90() /* reduce AAgrammar91Grammar */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PHelpers pHelpersNode3 = (PHelpers)popped1.get(0);
        PTokens pTokensNode5 = (PTokens)popped2.get(0);
        PIgnTokens pIgnTokensNode6 = (PIgnTokens)popped3.get(0);
        PAst pAstNode8 = (PAst)popped4.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), pHelpersNode3, null, pTokensNode5, pIgnTokensNode6, null, pAstNode8);
        computePositions(pGrammarNode1, popped1, popped4);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new91() /* reduce AAgrammar92Grammar */
    {
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PHelpers pHelpersNode4 = (PHelpers)popped2.get(0);
        PTokens pTokensNode6 = (PTokens)popped3.get(0);
        PIgnTokens pIgnTokensNode7 = (PIgnTokens)popped4.get(0);
        PAst pAstNode9 = (PAst)popped5.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, pHelpersNode4, null, pTokensNode6, pIgnTokensNode7, null, pAstNode9);
        computePositions(pGrammarNode1, popped1, popped5);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new92() /* reduce AAgrammar93Grammar */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PStates pStatesNode4 = (PStates)popped1.get(0);
        PTokens pTokensNode5 = (PTokens)popped2.get(0);
        PIgnTokens pIgnTokensNode6 = (PIgnTokens)popped3.get(0);
        PAst pAstNode8 = (PAst)popped4.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), null, pStatesNode4, pTokensNode5, pIgnTokensNode6, null, pAstNode8);
        computePositions(pGrammarNode1, popped1, popped4);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new93() /* reduce AAgrammar94Grammar */
    {
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PStates pStatesNode5 = (PStates)popped2.get(0);
        PTokens pTokensNode6 = (PTokens)popped3.get(0);
        PIgnTokens pIgnTokensNode7 = (PIgnTokens)popped4.get(0);
        PAst pAstNode9 = (PAst)popped5.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, null, pStatesNode5, pTokensNode6, pIgnTokensNode7, null, pAstNode9);
        computePositions(pGrammarNode1, popped1, popped5);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new94() /* reduce AAgrammar95Grammar */
    {
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PHelpers pHelpersNode3 = (PHelpers)popped1.get(0);
        PStates pStatesNode4 = (PStates)popped2.get(0);
        PTokens pTokensNode5 = (PTokens)popped3.get(0);
        PIgnTokens pIgnTokensNode6 = (PIgnTokens)popped4.get(0);
        PAst pAstNode8 = (PAst)popped5.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), pHelpersNode3, pStatesNode4, pTokensNode5, pIgnTokensNode6, null, pAstNode8);
        computePositions(pGrammarNode1, popped1, popped5);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new95() /* reduce AAgrammar96Grammar */
    {
        List<?> popped6 = pop();
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PHelpers pHelpersNode4 = (PHelpers)popped2.get(0);
        PStates pStatesNode5 = (PStates)popped3.get(0);
        PTokens pTokensNode6 = (PTokens)popped4.get(0);
        PIgnTokens pIgnTokensNode7 = (PIgnTokens)popped5.get(0);
        PAst pAstNode9 = (PAst)popped6.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, pHelpersNode4, pStatesNode5, pTokensNode6, pIgnTokensNode7, null, pAstNode9);
        computePositions(pGrammarNode1, popped1, popped6);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new96() /* reduce AAgrammar97Grammar */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PProductions pProductionsNode7 = (PProductions)popped1.get(0);
        PAst pAstNode8 = (PAst)popped2.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), null, null, null, null, pProductionsNode7, pAstNode8);
        computePositions(pGrammarNode1, popped1, popped2);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new97() /* reduce AAgrammar98Grammar */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PProductions pProductionsNode8 = (PProductions)popped2.get(0);
        PAst pAstNode9 = (PAst)popped3.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, null, null, null, null, pProductionsNode8, pAstNode9);
        computePositions(pGrammarNode1, popped1, popped3);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new98() /* reduce AAgrammar99Grammar */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PHelpers pHelpersNode3 = (PHelpers)popped1.get(0);
        PProductions pProductionsNode7 = (PProductions)popped2.get(0);
        PAst pAstNode8 = (PAst)popped3.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), pHelpersNode3, null, null, null, pProductionsNode7, pAstNode8);
        computePositions(pGrammarNode1, popped1, popped3);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new99() /* reduce AAgrammar100Grammar */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PHelpers pHelpersNode4 = (PHelpers)popped2.get(0);
        PProductions pProductionsNode8 = (PProductions)popped3.get(0);
        PAst pAstNode9 = (PAst)popped4.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, pHelpersNode4, null, null, null, pProductionsNode8, pAstNode9);
        computePositions(pGrammarNode1, popped1, popped4);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new100() /* reduce AAgrammar101Grammar */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PStates pStatesNode4 = (PStates)popped1.get(0);
        PProductions pProductionsNode7 = (PProductions)popped2.get(0);
        PAst pAstNode8 = (PAst)popped3.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), null, pStatesNode4, null, null, pProductionsNode7, pAstNode8);
        computePositions(pGrammarNode1, popped1, popped3);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new101() /* reduce AAgrammar102Grammar */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PStates pStatesNode5 = (PStates)popped2.get(0);
        PProductions pProductionsNode8 = (PProductions)popped3.get(0);
        PAst pAstNode9 = (PAst)popped4.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, null, pStatesNode5, null, null, pProductionsNode8, pAstNode9);
        computePositions(pGrammarNode1, popped1, popped4);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new102() /* reduce AAgrammar103Grammar */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PHelpers pHelpersNode3 = (PHelpers)popped1.get(0);
        PStates pStatesNode4 = (PStates)popped2.get(0);
        PProductions pProductionsNode7 = (PProductions)popped3.get(0);
        PAst pAstNode8 = (PAst)popped4.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), pHelpersNode3, pStatesNode4, null, null, pProductionsNode7, pAstNode8);
        computePositions(pGrammarNode1, popped1, popped4);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new103() /* reduce AAgrammar104Grammar */
    {
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PHelpers pHelpersNode4 = (PHelpers)popped2.get(0);
        PStates pStatesNode5 = (PStates)popped3.get(0);
        PProductions pProductionsNode8 = (PProductions)popped4.get(0);
        PAst pAstNode9 = (PAst)popped5.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, pHelpersNode4, pStatesNode5, null, null, pProductionsNode8, pAstNode9);
        computePositions(pGrammarNode1, popped1, popped5);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new104() /* reduce AAgrammar105Grammar */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PTokens pTokensNode5 = (PTokens)popped1.get(0);
        PProductions pProductionsNode7 = (PProductions)popped2.get(0);
        PAst pAstNode8 = (PAst)popped3.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), null, null, pTokensNode5, null, pProductionsNode7, pAstNode8);
        computePositions(pGrammarNode1, popped1, popped3);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new105() /* reduce AAgrammar106Grammar */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PTokens pTokensNode6 = (PTokens)popped2.get(0);
        PProductions pProductionsNode8 = (PProductions)popped3.get(0);
        PAst pAstNode9 = (PAst)popped4.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, null, null, pTokensNode6, null, pProductionsNode8, pAstNode9);
        computePositions(pGrammarNode1, popped1, popped4);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new106() /* reduce AAgrammar107Grammar */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PHelpers pHelpersNode3 = (PHelpers)popped1.get(0);
        PTokens pTokensNode5 = (PTokens)popped2.get(0);
        PProductions pProductionsNode7 = (PProductions)popped3.get(0);
        PAst pAstNode8 = (PAst)popped4.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), pHelpersNode3, null, pTokensNode5, null, pProductionsNode7, pAstNode8);
        computePositions(pGrammarNode1, popped1, popped4);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new107() /* reduce AAgrammar108Grammar */
    {
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PHelpers pHelpersNode4 = (PHelpers)popped2.get(0);
        PTokens pTokensNode6 = (PTokens)popped3.get(0);
        PProductions pProductionsNode8 = (PProductions)popped4.get(0);
        PAst pAstNode9 = (PAst)popped5.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, pHelpersNode4, null, pTokensNode6, null, pProductionsNode8, pAstNode9);
        computePositions(pGrammarNode1, popped1, popped5);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new108() /* reduce AAgrammar109Grammar */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PStates pStatesNode4 = (PStates)popped1.get(0);
        PTokens pTokensNode5 = (PTokens)popped2.get(0);
        PProductions pProductionsNode7 = (PProductions)popped3.get(0);
        PAst pAstNode8 = (PAst)popped4.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), null, pStatesNode4, pTokensNode5, null, pProductionsNode7, pAstNode8);
        computePositions(pGrammarNode1, popped1, popped4);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new109() /* reduce AAgrammar110Grammar */
    {
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PStates pStatesNode5 = (PStates)popped2.get(0);
        PTokens pTokensNode6 = (PTokens)popped3.get(0);
        PProductions pProductionsNode8 = (PProductions)popped4.get(0);
        PAst pAstNode9 = (PAst)popped5.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, null, pStatesNode5, pTokensNode6, null, pProductionsNode8, pAstNode9);
        computePositions(pGrammarNode1, popped1, popped5);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new110() /* reduce AAgrammar111Grammar */
    {
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PHelpers pHelpersNode3 = (PHelpers)popped1.get(0);
        PStates pStatesNode4 = (PStates)popped2.get(0);
        PTokens pTokensNode5 = (PTokens)popped3.get(0);
        PProductions pProductionsNode7 = (PProductions)popped4.get(0);
        PAst pAstNode8 = (PAst)popped5.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), pHelpersNode3, pStatesNode4, pTokensNode5, null, pProductionsNode7, pAstNode8);
        computePositions(pGrammarNode1, popped1, popped5);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new111() /* reduce AAgrammar112Grammar */
    {
        List<?> popped6 = pop();
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PHelpers pHelpersNode4 = (PHelpers)popped2.get(0);
        PStates pStatesNode5 = (PStates)popped3.get(0);
        PTokens pTokensNode6 = (PTokens)popped4.get(0);
        PProductions pProductionsNode8 = (PProductions)popped5.get(0);
        PAst pAstNode9 = (PAst)popped6.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, pHelpersNode4, pStatesNode5, pTokensNode6, null, pProductionsNode8, pAstNode9);
        computePositions(pGrammarNode1, popped1, popped6);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new112() /* reduce AAgrammar113Grammar */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PIgnTokens pIgnTokensNode6 = (PIgnTokens)popped1.get(0);
        PProductions pProductionsNode7 = (PProductions)popped2.get(0);
        PAst pAstNode8 = (PAst)popped3.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), null, null, null, pIgnTokensNode6, pProductionsNode7, pAstNode8);
        computePositions(pGrammarNode1, popped1, popped3);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new113() /* reduce AAgrammar114Grammar */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PIgnTokens pIgnTokensNode7 = (PIgnTokens)popped2.get(0);
        PProductions pProductionsNode8 = (PProductions)popped3.get(0);
        PAst pAstNode9 = (PAst)popped4.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, null, null, null, pIgnTokensNode7, pProductionsNode8, pAstNode9);
        computePositions(pGrammarNode1, popped1, popped4);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new114() /* reduce AAgrammar115Grammar */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PHelpers pHelpersNode3 = (PHelpers)popped1.get(0);
        PIgnTokens pIgnTokensNode6 = (PIgnTokens)popped2.get(0);
        PProductions pProductionsNode7 = (PProductions)popped3.get(0);
        PAst pAstNode8 = (PAst)popped4.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), pHelpersNode3, null, null, pIgnTokensNode6, pProductionsNode7, pAstNode8);
        computePositions(pGrammarNode1, popped1, popped4);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new115() /* reduce AAgrammar116Grammar */
    {
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PHelpers pHelpersNode4 = (PHelpers)popped2.get(0);
        PIgnTokens pIgnTokensNode7 = (PIgnTokens)popped3.get(0);
        PProductions pProductionsNode8 = (PProductions)popped4.get(0);
        PAst pAstNode9 = (PAst)popped5.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, pHelpersNode4, null, null, pIgnTokensNode7, pProductionsNode8, pAstNode9);
        computePositions(pGrammarNode1, popped1, popped5);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new116() /* reduce AAgrammar117Grammar */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PStates pStatesNode4 = (PStates)popped1.get(0);
        PIgnTokens pIgnTokensNode6 = (PIgnTokens)popped2.get(0);
        PProductions pProductionsNode7 = (PProductions)popped3.get(0);
        PAst pAstNode8 = (PAst)popped4.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), null, pStatesNode4, null, pIgnTokensNode6, pProductionsNode7, pAstNode8);
        computePositions(pGrammarNode1, popped1, popped4);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new117() /* reduce AAgrammar118Grammar */
    {
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PStates pStatesNode5 = (PStates)popped2.get(0);
        PIgnTokens pIgnTokensNode7 = (PIgnTokens)popped3.get(0);
        PProductions pProductionsNode8 = (PProductions)popped4.get(0);
        PAst pAstNode9 = (PAst)popped5.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, null, pStatesNode5, null, pIgnTokensNode7, pProductionsNode8, pAstNode9);
        computePositions(pGrammarNode1, popped1, popped5);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new118() /* reduce AAgrammar119Grammar */
    {
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PHelpers pHelpersNode3 = (PHelpers)popped1.get(0);
        PStates pStatesNode4 = (PStates)popped2.get(0);
        PIgnTokens pIgnTokensNode6 = (PIgnTokens)popped3.get(0);
        PProductions pProductionsNode7 = (PProductions)popped4.get(0);
        PAst pAstNode8 = (PAst)popped5.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), pHelpersNode3, pStatesNode4, null, pIgnTokensNode6, pProductionsNode7, pAstNode8);
        computePositions(pGrammarNode1, popped1, popped5);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new119() /* reduce AAgrammar120Grammar */
    {
        List<?> popped6 = pop();
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PHelpers pHelpersNode4 = (PHelpers)popped2.get(0);
        PStates pStatesNode5 = (PStates)popped3.get(0);
        PIgnTokens pIgnTokensNode7 = (PIgnTokens)popped4.get(0);
        PProductions pProductionsNode8 = (PProductions)popped5.get(0);
        PAst pAstNode9 = (PAst)popped6.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, pHelpersNode4, pStatesNode5, null, pIgnTokensNode7, pProductionsNode8, pAstNode9);
        computePositions(pGrammarNode1, popped1, popped6);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new120() /* reduce AAgrammar121Grammar */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PTokens pTokensNode5 = (PTokens)popped1.get(0);
        PIgnTokens pIgnTokensNode6 = (PIgnTokens)popped2.get(0);
        PProductions pProductionsNode7 = (PProductions)popped3.get(0);
        PAst pAstNode8 = (PAst)popped4.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), null, null, pTokensNode5, pIgnTokensNode6, pProductionsNode7, pAstNode8);
        computePositions(pGrammarNode1, popped1, popped4);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new121() /* reduce AAgrammar122Grammar */
    {
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PTokens pTokensNode6 = (PTokens)popped2.get(0);
        PIgnTokens pIgnTokensNode7 = (PIgnTokens)popped3.get(0);
        PProductions pProductionsNode8 = (PProductions)popped4.get(0);
        PAst pAstNode9 = (PAst)popped5.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, null, null, pTokensNode6, pIgnTokensNode7, pProductionsNode8, pAstNode9);
        computePositions(pGrammarNode1, popped1, popped5);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new122() /* reduce AAgrammar123Grammar */
    {
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PHelpers pHelpersNode3 = (PHelpers)popped1.get(0);
        PTokens pTokensNode5 = (PTokens)popped2.get(0);
        PIgnTokens pIgnTokensNode6 = (PIgnTokens)popped3.get(0);
        PProductions pProductionsNode7 = (PProductions)popped4.get(0);
        PAst pAstNode8 = (PAst)popped5.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), pHelpersNode3, null, pTokensNode5, pIgnTokensNode6, pProductionsNode7, pAstNode8);
        computePositions(pGrammarNode1, popped1, popped5);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new123() /* reduce AAgrammar124Grammar */
    {
        List<?> popped6 = pop();
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PHelpers pHelpersNode4 = (PHelpers)popped2.get(0);
        PTokens pTokensNode6 = (PTokens)popped3.get(0);
        PIgnTokens pIgnTokensNode7 = (PIgnTokens)popped4.get(0);
        PProductions pProductionsNode8 = (PProductions)popped5.get(0);
        PAst pAstNode9 = (PAst)popped6.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, pHelpersNode4, null, pTokensNode6, pIgnTokensNode7, pProductionsNode8, pAstNode9);
        computePositions(pGrammarNode1, popped1, popped6);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new124() /* reduce AAgrammar125Grammar */
    {
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PStates pStatesNode4 = (PStates)popped1.get(0);
        PTokens pTokensNode5 = (PTokens)popped2.get(0);
        PIgnTokens pIgnTokensNode6 = (PIgnTokens)popped3.get(0);
        PProductions pProductionsNode7 = (PProductions)popped4.get(0);
        PAst pAstNode8 = (PAst)popped5.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), null, pStatesNode4, pTokensNode5, pIgnTokensNode6, pProductionsNode7, pAstNode8);
        computePositions(pGrammarNode1, popped1, popped5);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new125() /* reduce AAgrammar126Grammar */
    {
        List<?> popped6 = pop();
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PStates pStatesNode5 = (PStates)popped2.get(0);
        PTokens pTokensNode6 = (PTokens)popped3.get(0);
        PIgnTokens pIgnTokensNode7 = (PIgnTokens)popped4.get(0);
        PProductions pProductionsNode8 = (PProductions)popped5.get(0);
        PAst pAstNode9 = (PAst)popped6.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, null, pStatesNode5, pTokensNode6, pIgnTokensNode7, pProductionsNode8, pAstNode9);
        computePositions(pGrammarNode1, popped1, popped6);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new126() /* reduce AAgrammar127Grammar */
    {
        List<?> popped6 = pop();
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PHelpers pHelpersNode3 = (PHelpers)popped1.get(0);
        PStates pStatesNode4 = (PStates)popped2.get(0);
        PTokens pTokensNode5 = (PTokens)popped3.get(0);
        PIgnTokens pIgnTokensNode6 = (PIgnTokens)popped4.get(0);
        PProductions pProductionsNode7 = (PProductions)popped5.get(0);
        PAst pAstNode8 = (PAst)popped6.get(0);
        AGrammar pGrammarNode1 = new AGrammar(Collections.emptyList(), pHelpersNode3, pStatesNode4, pTokensNode5, pIgnTokensNode6, pProductionsNode7, pAstNode8);
        computePositions(pGrammarNode1, popped1, popped6);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new127() /* reduce AAgrammar128Grammar */
    {
        List<?> popped7 = pop();
        List<?> popped6 = pop();
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TPkgId> listNode2 = (List<TPkgId>)popped1.get(0);
        List<TPkgId> listNode3 = listNode2;
        PHelpers pHelpersNode4 = (PHelpers)popped2.get(0);
        PStates pStatesNode5 = (PStates)popped3.get(0);
        PTokens pTokensNode6 = (PTokens)popped4.get(0);
        PIgnTokens pIgnTokensNode7 = (PIgnTokens)popped5.get(0);
        PProductions pProductionsNode8 = (PProductions)popped6.get(0);
        PAst pAstNode9 = (PAst)popped7.get(0);
        AGrammar pGrammarNode1 = new AGrammar(listNode3, pHelpersNode4, pStatesNode5, pTokensNode6, pIgnTokensNode7, pProductionsNode8, pAstNode9);
        computePositions(pGrammarNode1, popped1, popped7);

        return Collections.singletonList(pGrammarNode1);
    }

    private List<?> new128() /* reduce APackage */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        List<TPkgId> listNode1 = (List<TPkgId>)popped2.get(0);
        List<TPkgId> listNode2 = listNode1;
        return Collections.singletonList(listNode2);
    }

    private List<?> new129() /* reduce AApkgname1PkgName */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        TPkgId tPkgIdNode1 = (TPkgId)popped1.get(0);
        List<TPkgId> listNode2;
        if(tPkgIdNode1 != null) {
            listNode2 = Collections.singletonList(tPkgIdNode1);
        } else {
            listNode2 = Collections.emptyList();
        }
        return Collections.singletonList(listNode2);
    }

    private List<?> new130() /* reduce AApkgname2PkgName */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        TPkgId tPkgIdNode1 = (TPkgId)popped1.get(0);
        List<TPkgId> listNode2 = (List<TPkgId>)popped2.get(0);
        List<TPkgId> listNode3 = new LinkedList<>();
        if(tPkgIdNode1 != null)
        {
            listNode3.add(tPkgIdNode1);
        }
        if (listNode3.isEmpty() && listNode2 instanceof LinkedList<?>) {
            listNode3 = listNode2;
        } else {
            listNode3.addAll(listNode2);
        }
        return Collections.singletonList(listNode3);
    }

    private List<?> new131() /* reduce APkgNameTail */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        TPkgId tPkgIdNode1 = (TPkgId)popped2.get(0);
        return Collections.singletonList(tPkgIdNode1);
    }

    private List<?> new132() /* reduce AHelpers */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<PHelperDef> listNode2 = (List<PHelperDef>)popped2.get(0);
        List<PHelperDef> listNode3 = listNode2;
        AHelpers pHelpersNode1 = new AHelpers(listNode3);
        computePositions(pHelpersNode1, popped1, popped2);

        return Collections.singletonList(pHelpersNode1);
    }

    private List<?> new133() /* reduce AHelperDef */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        TId tIdNode2 = (TId)popped1.get(0);
        PRegExp pRegExpNode3 = (PRegExp)popped3.get(0);
        AHelperDef pHelperDefNode1 = new AHelperDef(tIdNode2, pRegExpNode3);
        computePositions(pHelperDefNode1, popped1, popped4);

        return Collections.singletonList(pHelperDefNode1);
    }

    private List<?> new134() /* reduce AStates */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TId> listNode2 = (List<TId>)popped2.get(0);
        List<TId> listNode3 = listNode2;
        AStates pStatesNode1 = new AStates(listNode3);
        computePositions(pStatesNode1, popped1, popped3);

        return Collections.singletonList(pStatesNode1);
    }

    private List<?> new135() /* reduce AAidlist1IdList */
    {
        List<?> popped1 = pop();
        TId tIdNode1 = (TId)popped1.get(0);
        List<TId> listNode2;
        if(tIdNode1 != null) {
            listNode2 = Collections.singletonList(tIdNode1);
        } else {
            listNode2 = Collections.emptyList();
        }
        return Collections.singletonList(listNode2);
    }

    private List<?> new136() /* reduce AAidlist2IdList */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        TId tIdNode1 = (TId)popped1.get(0);
        List<TId> listNode2 = (List<TId>)popped2.get(0);
        List<TId> listNode3 = new LinkedList<>();
        if(tIdNode1 != null)
        {
            listNode3.add(tIdNode1);
        }
        if (listNode3.isEmpty() && listNode2 instanceof LinkedList<?>) {
            listNode3 = listNode2;
        } else {
            listNode3.addAll(listNode2);
        }
        return Collections.singletonList(listNode3);
    }

    private List<?> new137() /* reduce AIdListTail */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        TId tIdNode1 = (TId)popped2.get(0);
        return Collections.singletonList(tIdNode1);
    }

    private List<?> new138() /* reduce ATokens */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<PTokenDef> listNode2 = (List<PTokenDef>)popped2.get(0);
        List<PTokenDef> listNode3 = listNode2;
        ATokens pTokensNode1 = new ATokens(listNode3);
        computePositions(pTokensNode1, popped1, popped2);

        return Collections.singletonList(pTokensNode1);
    }

    private List<?> new139() /* reduce AAtokendef1TokenDef */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        TId tIdNode3 = (TId)popped1.get(0);
        PRegExp pRegExpNode4 = (PRegExp)popped3.get(0);
        ATokenDef pTokenDefNode1 = new ATokenDef(null, tIdNode3, pRegExpNode4, null, null);
        computePositions(pTokenDefNode1, popped1, popped4);

        return Collections.singletonList(pTokenDefNode1);
    }

    private List<?> new140() /* reduce AAtokendef2TokenDef */
    {
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PStateList pStateListNode2 = (PStateList)popped1.get(0);
        TId tIdNode3 = (TId)popped2.get(0);
        PRegExp pRegExpNode4 = (PRegExp)popped4.get(0);
        ATokenDef pTokenDefNode1 = new ATokenDef(pStateListNode2, tIdNode3, pRegExpNode4, null, null);
        computePositions(pTokenDefNode1, popped1, popped5);

        return Collections.singletonList(pTokenDefNode1);
    }

    private List<?> new141() /* reduce AAtokendef3TokenDef */
    {
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        TId tIdNode3 = (TId)popped1.get(0);
        PRegExp pRegExpNode4 = (PRegExp)popped3.get(0);
        TSlash tSlashNode5 = (TSlash)popped4.get(0);
        PRegExp pRegExpNode6 = (PRegExp)popped4.get(1);
        ATokenDef pTokenDefNode1 = new ATokenDef(null, tIdNode3, pRegExpNode4, tSlashNode5, pRegExpNode6);
        computePositions(pTokenDefNode1, popped1, popped5);

        return Collections.singletonList(pTokenDefNode1);
    }

    private List<?> new142() /* reduce AAtokendef4TokenDef */
    {
        List<?> popped6 = pop();
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PStateList pStateListNode2 = (PStateList)popped1.get(0);
        TId tIdNode3 = (TId)popped2.get(0);
        PRegExp pRegExpNode4 = (PRegExp)popped4.get(0);
        TSlash tSlashNode5 = (TSlash)popped5.get(0);
        PRegExp pRegExpNode6 = (PRegExp)popped5.get(1);
        ATokenDef pTokenDefNode1 = new ATokenDef(pStateListNode2, tIdNode3, pRegExpNode4, tSlashNode5, pRegExpNode6);
        computePositions(pTokenDefNode1, popped1, popped6);

        return Collections.singletonList(pTokenDefNode1);
    }

    private List<?> new143() /* reduce AAstatelist1StateList */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        TId tIdNode2 = (TId)popped2.get(0);
        AStateList pStateListNode1 = new AStateList(tIdNode2, null, Collections.emptyList());
        computePositions(pStateListNode1, popped1, popped3);

        return Collections.singletonList(pStateListNode1);
    }

    private List<?> new144() /* reduce AAstatelist2StateList */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        TId tIdNode2 = (TId)popped2.get(0);
        PTransition pTransitionNode3 = (PTransition)popped3.get(0);
        AStateList pStateListNode1 = new AStateList(tIdNode2, pTransitionNode3, Collections.emptyList());
        computePositions(pStateListNode1, popped1, popped4);

        return Collections.singletonList(pStateListNode1);
    }

    private List<?> new145() /* reduce AAstatelist3StateList */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        TId tIdNode2 = (TId)popped2.get(0);
        List<PStateListTail> listNode4 = (List<PStateListTail>)popped3.get(0);
        List<PStateListTail> listNode5 = listNode4;
        AStateList pStateListNode1 = new AStateList(tIdNode2, null, listNode5);
        computePositions(pStateListNode1, popped1, popped4);

        return Collections.singletonList(pStateListNode1);
    }

    private List<?> new146() /* reduce AAstatelist4StateList */
    {
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        TId tIdNode2 = (TId)popped2.get(0);
        PTransition pTransitionNode3 = (PTransition)popped3.get(0);
        List<PStateListTail> listNode4 = (List<PStateListTail>)popped4.get(0);
        List<PStateListTail> listNode5 = listNode4;
        AStateList pStateListNode1 = new AStateList(tIdNode2, pTransitionNode3, listNode5);
        computePositions(pStateListNode1, popped1, popped5);

        return Collections.singletonList(pStateListNode1);
    }

    private List<?> new147() /* reduce AAstatelisttail1StateListTail */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        TId tIdNode2 = (TId)popped2.get(0);
        AStateListTail pStateListTailNode1 = new AStateListTail(tIdNode2, null);
        computePositions(pStateListTailNode1, popped1, popped2);

        return Collections.singletonList(pStateListTailNode1);
    }

    private List<?> new148() /* reduce AAstatelisttail2StateListTail */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        TId tIdNode2 = (TId)popped2.get(0);
        PTransition pTransitionNode3 = (PTransition)popped3.get(0);
        AStateListTail pStateListTailNode1 = new AStateListTail(tIdNode2, pTransitionNode3);
        computePositions(pStateListTailNode1, popped1, popped3);

        return Collections.singletonList(pStateListTailNode1);
    }

    private List<?> new149() /* reduce ATransition */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        TId tIdNode2 = (TId)popped2.get(0);
        ATransition pTransitionNode1 = new ATransition(tIdNode2);
        computePositions(pTransitionNode1, popped1, popped2);

        return Collections.singletonList(pTransitionNode1);
    }

    private List<?> new150() /* reduce AAigntokens1IgnTokens */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        AIgnTokens pIgnTokensNode1 = new AIgnTokens(Collections.emptyList());
        computePositions(pIgnTokensNode1, popped1, popped3);

        return Collections.singletonList(pIgnTokensNode1);
    }

    private List<?> new151() /* reduce AAigntokens2IgnTokens */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<TId> listNode2 = (List<TId>)popped3.get(0);
        List<TId> listNode3 = listNode2;
        AIgnTokens pIgnTokensNode1 = new AIgnTokens(listNode3);
        computePositions(pIgnTokensNode1, popped1, popped4);

        return Collections.singletonList(pIgnTokensNode1);
    }

    private List<?> new152() /* reduce ALookAhead */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        TSlash tSlashNode1 = (TSlash)popped1.get(0);
        PRegExp pRegExpNode2 = (PRegExp)popped2.get(0);
        return Arrays.asList(new Object[] {
            tSlashNode1,
            pRegExpNode2,
        });
    }

    private List<?> new153() /* reduce AAregexp1RegExp */
    {
        List<?> popped1 = pop();

        PConcat pConcatNode2 = (PConcat)popped1.get(0);
        List<PConcat> listNode3;
        if(pConcatNode2 != null) {
            listNode3 = Collections.singletonList(pConcatNode2);
        } else {
            listNode3 = Collections.emptyList();
        }
        ARegExp pRegExpNode1 = new ARegExp(listNode3);
        computePositions(pRegExpNode1, popped1, popped1);

        return Collections.singletonList(pRegExpNode1);
    }

    private List<?> new154() /* reduce AAregexp2RegExp */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PConcat pConcatNode2 = (PConcat)popped1.get(0);
        List<PConcat> listNode3 = (List<PConcat>)popped2.get(0);
        List<PConcat> listNode4 = new LinkedList<>();
        if(pConcatNode2 != null)
        {
            listNode4.add(pConcatNode2);
        }
        if (listNode4.isEmpty() && listNode3 instanceof LinkedList<?>) {
            listNode4 = listNode3;
        } else {
            listNode4.addAll(listNode3);
        }
        ARegExp pRegExpNode1 = new ARegExp(listNode4);
        computePositions(pRegExpNode1, popped1, popped2);

        return Collections.singletonList(pRegExpNode1);
    }

    private List<?> new155() /* reduce ARegExpTail */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        PConcat pConcatNode1 = (PConcat)popped2.get(0);
        return Collections.singletonList(pConcatNode1);
    }

    private List<?> new156() /* reduce AAconcat1Concat */
    {

        AConcat pConcatNode1 = new AConcat(Collections.emptyList());

        return Collections.singletonList(pConcatNode1);
    }

    private List<?> new157() /* reduce AAconcat2Concat */
    {
        List<?> popped1 = pop();

        List<PUnExp> listNode2 = (List<PUnExp>)popped1.get(0);
        List<PUnExp> listNode3 = listNode2;
        AConcat pConcatNode1 = new AConcat(listNode3);
        computePositions(pConcatNode1, popped1, popped1);

        return Collections.singletonList(pConcatNode1);
    }

    private List<?> new158() /* reduce AAunexp1UnExp */
    {
        List<?> popped1 = pop();

        PBasic pBasicNode2 = (PBasic)popped1.get(0);
        AUnExp pUnExpNode1 = new AUnExp(pBasicNode2, null);
        computePositions(pUnExpNode1, popped1, popped1);

        return Collections.singletonList(pUnExpNode1);
    }

    private List<?> new159() /* reduce AAunexp2UnExp */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PBasic pBasicNode2 = (PBasic)popped1.get(0);
        PUnOp pUnOpNode3 = (PUnOp)popped2.get(0);
        AUnExp pUnExpNode1 = new AUnExp(pBasicNode2, pUnOpNode3);
        computePositions(pUnExpNode1, popped1, popped2);

        return Collections.singletonList(pUnExpNode1);
    }

    private List<?> new160() /* reduce ACharBasic */
    {
        List<?> popped1 = pop();

        PChar pCharNode2 = (PChar)popped1.get(0);
        ACharBasic pBasicNode1 = new ACharBasic(pCharNode2);
        computePositions(pBasicNode1, popped1, popped1);

        return Collections.singletonList(pBasicNode1);
    }

    private List<?> new161() /* reduce ASetBasic */
    {
        List<?> popped1 = pop();

        PSet pSetNode2 = (PSet)popped1.get(0);
        ASetBasic pBasicNode1 = new ASetBasic(pSetNode2);
        computePositions(pBasicNode1, popped1, popped1);

        return Collections.singletonList(pBasicNode1);
    }

    private List<?> new162() /* reduce AStringBasic */
    {
        List<?> popped1 = pop();

        TString tStringNode2 = (TString)popped1.get(0);
        AStringBasic pBasicNode1 = new AStringBasic(tStringNode2);
        computePositions(pBasicNode1, popped1, popped1);

        return Collections.singletonList(pBasicNode1);
    }

    private List<?> new163() /* reduce AIdBasic */
    {
        List<?> popped1 = pop();

        TId tIdNode2 = (TId)popped1.get(0);
        AIdBasic pBasicNode1 = new AIdBasic(tIdNode2);
        computePositions(pBasicNode1, popped1, popped1);

        return Collections.singletonList(pBasicNode1);
    }

    private List<?> new164() /* reduce ARegExpBasic */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PRegExp pRegExpNode2 = (PRegExp)popped2.get(0);
        ARegExpBasic pBasicNode1 = new ARegExpBasic(pRegExpNode2);
        computePositions(pBasicNode1, popped1, popped3);

        return Collections.singletonList(pBasicNode1);
    }

    private List<?> new165() /* reduce ACharChar */
    {
        List<?> popped1 = pop();

        TChar tCharNode2 = (TChar)popped1.get(0);
        ACharChar pCharNode1 = new ACharChar(tCharNode2);
        computePositions(pCharNode1, popped1, popped1);

        return Collections.singletonList(pCharNode1);
    }

    private List<?> new166() /* reduce ADecChar */
    {
        List<?> popped1 = pop();

        TDecChar tDecCharNode2 = (TDecChar)popped1.get(0);
        ADecChar pCharNode1 = new ADecChar(tDecCharNode2);
        computePositions(pCharNode1, popped1, popped1);

        return Collections.singletonList(pCharNode1);
    }

    private List<?> new167() /* reduce AHexChar */
    {
        List<?> popped1 = pop();

        THexChar tHexCharNode2 = (THexChar)popped1.get(0);
        AHexChar pCharNode1 = new AHexChar(tHexCharNode2);
        computePositions(pCharNode1, popped1, popped1);

        return Collections.singletonList(pCharNode1);
    }

    private List<?> new168() /* reduce AOperationSet */
    {
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PBasic pBasicNode2 = (PBasic)popped2.get(0);
        PBinOp pBinOpNode3 = (PBinOp)popped3.get(0);
        PBasic pBasicNode4 = (PBasic)popped4.get(0);
        AOperationSet pSetNode1 = new AOperationSet(pBasicNode2, pBinOpNode3, pBasicNode4);
        computePositions(pSetNode1, popped1, popped5);

        return Collections.singletonList(pSetNode1);
    }

    private List<?> new169() /* reduce AIntervalSet */
    {
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PChar pCharNode2 = (PChar)popped2.get(0);
        PChar pCharNode3 = (PChar)popped4.get(0);
        AIntervalSet pSetNode1 = new AIntervalSet(pCharNode2, pCharNode3);
        computePositions(pSetNode1, popped1, popped5);

        return Collections.singletonList(pSetNode1);
    }

    private List<?> new170() /* reduce AStarUnOp */
    {
        List<?> popped1 = pop();

        TStar tStarNode2 = (TStar)popped1.get(0);
        AStarUnOp pUnOpNode1 = new AStarUnOp(tStarNode2);
        computePositions(pUnOpNode1, popped1, popped1);

        return Collections.singletonList(pUnOpNode1);
    }

    private List<?> new171() /* reduce AQMarkUnOp */
    {
        List<?> popped1 = pop();

        TQMark tQMarkNode2 = (TQMark)popped1.get(0);
        AQMarkUnOp pUnOpNode1 = new AQMarkUnOp(tQMarkNode2);
        computePositions(pUnOpNode1, popped1, popped1);

        return Collections.singletonList(pUnOpNode1);
    }

    private List<?> new172() /* reduce APlusUnOp */
    {
        List<?> popped1 = pop();

        TPlus tPlusNode2 = (TPlus)popped1.get(0);
        APlusUnOp pUnOpNode1 = new APlusUnOp(tPlusNode2);
        computePositions(pUnOpNode1, popped1, popped1);

        return Collections.singletonList(pUnOpNode1);
    }

    private List<?> new173() /* reduce APlusBinOp */
    {
        List<?> popped1 = pop();

        APlusBinOp pBinOpNode1 = new APlusBinOp();
        computePositions(pBinOpNode1, popped1, popped1);

        return Collections.singletonList(pBinOpNode1);
    }

    private List<?> new174() /* reduce AMinusBinOp */
    {
        List<?> popped1 = pop();

        AMinusBinOp pBinOpNode1 = new AMinusBinOp();
        computePositions(pBinOpNode1, popped1, popped1);

        return Collections.singletonList(pBinOpNode1);
    }

    private List<?> new175() /* reduce AProductions */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<PProd> listNode2 = (List<PProd>)popped2.get(0);
        List<PProd> listNode3 = listNode2;
        AProductions pProductionsNode1 = new AProductions(listNode3);
        computePositions(pProductionsNode1, popped1, popped2);

        return Collections.singletonList(pProductionsNode1);
    }

    private List<?> new176() /* reduce AAprod1Prod */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        TId tIdNode2 = (TId)popped1.get(0);
        List<PAlt> listNode5 = (List<PAlt>)popped3.get(0);
        List<PAlt> listNode6 = listNode5;
        AProd pProdNode1 = new AProd(tIdNode2, null, Collections.emptyList(), listNode6);
        computePositions(pProdNode1, popped1, popped4);

        return Collections.singletonList(pProdNode1);
    }

    private List<?> new177() /* reduce AAprod2Prod */
    {
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        TId tIdNode2 = (TId)popped1.get(0);
        TArrow tArrowNode3 = (TArrow)popped2.get(0);
        List<PElem> listNode4 = (List<PElem>)popped2.get(1);
        List<PElem> listNode5 = listNode4;
        List<PAlt> listNode6 = (List<PAlt>)popped4.get(0);
        List<PAlt> listNode7 = listNode6;
        AProd pProdNode1 = new AProd(tIdNode2, tArrowNode3, listNode5, listNode7);
        computePositions(pProdNode1, popped1, popped5);

        return Collections.singletonList(pProdNode1);
    }

    private List<?> new178() /* reduce AAprodtransform1ProdTransform */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        TArrow tArrowNode1 = (TArrow)popped2.get(0);
        return Arrays.asList(new Object[] {
            tArrowNode1,
            Collections.emptyList(),
        });
    }

    private List<?> new179() /* reduce AAprodtransform2ProdTransform */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        TArrow tArrowNode1 = (TArrow)popped2.get(0);
        List<PElem> listNode2 = (List<PElem>)popped3.get(0);
        List<PElem> listNode3 = listNode2;
        return Arrays.asList(new Object[] {
            tArrowNode1,
            listNode3,
        });
    }

    private List<?> new180() /* reduce AAalts1Alts */
    {
        List<?> popped1 = pop();
        PAlt pAltNode1 = (PAlt)popped1.get(0);
        List<PAlt> listNode2;
        if(pAltNode1 != null) {
            listNode2 = Collections.singletonList(pAltNode1);
        } else {
            listNode2 = Collections.emptyList();
        }
        return Collections.singletonList(listNode2);
    }

    private List<?> new181() /* reduce AAalts2Alts */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        PAlt pAltNode1 = (PAlt)popped1.get(0);
        List<PAlt> listNode2 = (List<PAlt>)popped2.get(0);
        List<PAlt> listNode3 = new LinkedList<>();
        if(pAltNode1 != null)
        {
            listNode3.add(pAltNode1);
        }
        if (listNode3.isEmpty() && listNode2 instanceof LinkedList<?>) {
            listNode3 = listNode2;
        } else {
            listNode3.addAll(listNode2);
        }
        return Collections.singletonList(listNode3);
    }

    private List<?> new182() /* reduce AAltsTail */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        PAlt pAltNode1 = (PAlt)popped2.get(0);
        return Collections.singletonList(pAltNode1);
    }

    private List<?> new183() /* reduce AAalt1Alt */
    {

        AAlt pAltNode1 = new AAlt(null, Collections.emptyList(), null);

        return Collections.singletonList(pAltNode1);
    }

    private List<?> new184() /* reduce AAalt2Alt */
    {
        List<?> popped1 = pop();

        TId tIdNode2 = (TId)popped1.get(0);
        AAlt pAltNode1 = new AAlt(tIdNode2, Collections.emptyList(), null);
        computePositions(pAltNode1, popped1, popped1);

        return Collections.singletonList(pAltNode1);
    }

    private List<?> new185() /* reduce AAalt3Alt */
    {
        List<?> popped1 = pop();

        List<PElem> listNode3 = (List<PElem>)popped1.get(0);
        List<PElem> listNode4 = listNode3;
        AAlt pAltNode1 = new AAlt(null, listNode4, null);
        computePositions(pAltNode1, popped1, popped1);

        return Collections.singletonList(pAltNode1);
    }

    private List<?> new186() /* reduce AAalt4Alt */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        TId tIdNode2 = (TId)popped1.get(0);
        List<PElem> listNode3 = (List<PElem>)popped2.get(0);
        List<PElem> listNode4 = listNode3;
        AAlt pAltNode1 = new AAlt(tIdNode2, listNode4, null);
        computePositions(pAltNode1, popped1, popped2);

        return Collections.singletonList(pAltNode1);
    }

    private List<?> new187() /* reduce AAalt5Alt */
    {
        List<?> popped1 = pop();

        PAltTransform pAltTransformNode4 = (PAltTransform)popped1.get(0);
        AAlt pAltNode1 = new AAlt(null, Collections.emptyList(), pAltTransformNode4);
        computePositions(pAltNode1, popped1, popped1);

        return Collections.singletonList(pAltNode1);
    }

    private List<?> new188() /* reduce AAalt6Alt */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        TId tIdNode2 = (TId)popped1.get(0);
        PAltTransform pAltTransformNode4 = (PAltTransform)popped2.get(0);
        AAlt pAltNode1 = new AAlt(tIdNode2, Collections.emptyList(), pAltTransformNode4);
        computePositions(pAltNode1, popped1, popped2);

        return Collections.singletonList(pAltNode1);
    }

    private List<?> new189() /* reduce AAalt7Alt */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<PElem> listNode3 = (List<PElem>)popped1.get(0);
        List<PElem> listNode4 = listNode3;
        PAltTransform pAltTransformNode5 = (PAltTransform)popped2.get(0);
        AAlt pAltNode1 = new AAlt(null, listNode4, pAltTransformNode5);
        computePositions(pAltNode1, popped1, popped2);

        return Collections.singletonList(pAltNode1);
    }

    private List<?> new190() /* reduce AAalt8Alt */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        TId tIdNode2 = (TId)popped1.get(0);
        List<PElem> listNode3 = (List<PElem>)popped2.get(0);
        List<PElem> listNode4 = listNode3;
        PAltTransform pAltTransformNode5 = (PAltTransform)popped3.get(0);
        AAlt pAltNode1 = new AAlt(tIdNode2, listNode4, pAltTransformNode5);
        computePositions(pAltNode1, popped1, popped3);

        return Collections.singletonList(pAltNode1);
    }

    private List<?> new191() /* reduce AAalttransform1AltTransform */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        TLBrace tLBraceNode2 = (TLBrace)popped1.get(0);
        TRBrace tRBraceNode4 = (TRBrace)popped3.get(0);
        AAltTransform pAltTransformNode1 = new AAltTransform(tLBraceNode2, Collections.emptyList(), tRBraceNode4);
        computePositions(pAltTransformNode1, popped1, popped3);

        return Collections.singletonList(pAltTransformNode1);
    }

    private List<?> new192() /* reduce AAalttransform2AltTransform */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        TLBrace tLBraceNode2 = (TLBrace)popped1.get(0);
        List<PTerm> listNode3 = (List<PTerm>)popped3.get(0);
        List<PTerm> listNode4 = listNode3;
        TRBrace tRBraceNode5 = (TRBrace)popped4.get(0);
        AAltTransform pAltTransformNode1 = new AAltTransform(tLBraceNode2, listNode4, tRBraceNode5);
        computePositions(pAltTransformNode1, popped1, popped4);

        return Collections.singletonList(pAltTransformNode1);
    }

    private List<?> new193() /* reduce AAnewterm1Term */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PProdName pProdNameNode2 = (PProdName)popped2.get(0);
        TLPar tLParNode3 = (TLPar)popped3.get(0);
        ANewTerm pTermNode1 = new ANewTerm(pProdNameNode2, tLParNode3, Collections.emptyList());
        computePositions(pTermNode1, popped1, popped4);

        return Collections.singletonList(pTermNode1);
    }

    private List<?> new194() /* reduce AAnewterm2Term */
    {
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PProdName pProdNameNode2 = (PProdName)popped2.get(0);
        TLPar tLParNode3 = (TLPar)popped3.get(0);
        List<PTerm> listNode4 = (List<PTerm>)popped4.get(0);
        List<PTerm> listNode5 = listNode4;
        ANewTerm pTermNode1 = new ANewTerm(pProdNameNode2, tLParNode3, listNode5);
        computePositions(pTermNode1, popped1, popped5);

        return Collections.singletonList(pTermNode1);
    }

    private List<?> new195() /* reduce AAlistterm1Term */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        TLBkt tLBktNode2 = (TLBkt)popped1.get(0);
        AListTerm pTermNode1 = new AListTerm(tLBktNode2, Collections.emptyList());
        computePositions(pTermNode1, popped1, popped2);

        return Collections.singletonList(pTermNode1);
    }

    private List<?> new196() /* reduce AAlistterm2Term */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        TLBkt tLBktNode2 = (TLBkt)popped1.get(0);
        List<PListTerm> listNode3 = (List<PListTerm>)popped2.get(0);
        List<PListTerm> listNode4 = listNode3;
        AListTerm pTermNode1 = new AListTerm(tLBktNode2, listNode4);
        computePositions(pTermNode1, popped1, popped3);

        return Collections.singletonList(pTermNode1);
    }

    private List<?> new197() /* reduce AAsimpleterm1Term */
    {
        List<?> popped1 = pop();

        TId tIdNode3 = (TId)popped1.get(0);
        ASimpleTerm pTermNode1 = new ASimpleTerm(null, tIdNode3, null);
        computePositions(pTermNode1, popped1, popped1);

        return Collections.singletonList(pTermNode1);
    }

    private List<?> new198() /* reduce AAsimpleterm2Term */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PSpecifier pSpecifierNode2 = (PSpecifier)popped1.get(0);
        TId tIdNode3 = (TId)popped2.get(0);
        ASimpleTerm pTermNode1 = new ASimpleTerm(pSpecifierNode2, tIdNode3, null);
        computePositions(pTermNode1, popped1, popped2);

        return Collections.singletonList(pTermNode1);
    }

    private List<?> new199() /* reduce AAsimpleterm3Term */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        TId tIdNode3 = (TId)popped1.get(0);
        TId tIdNode4 = (TId)popped2.get(0);
        ASimpleTerm pTermNode1 = new ASimpleTerm(null, tIdNode3, tIdNode4);
        computePositions(pTermNode1, popped1, popped2);

        return Collections.singletonList(pTermNode1);
    }

    private List<?> new200() /* reduce AAsimpleterm4Term */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PSpecifier pSpecifierNode2 = (PSpecifier)popped1.get(0);
        TId tIdNode3 = (TId)popped2.get(0);
        TId tIdNode4 = (TId)popped3.get(0);
        ASimpleTerm pTermNode1 = new ASimpleTerm(pSpecifierNode2, tIdNode3, tIdNode4);
        computePositions(pTermNode1, popped1, popped3);

        return Collections.singletonList(pTermNode1);
    }

    private List<?> new201() /* reduce ANullTerm */
    {
        List<?> popped1 = pop();

        ANullTerm pTermNode1 = new ANullTerm();
        computePositions(pTermNode1, popped1, popped1);

        return Collections.singletonList(pTermNode1);
    }

    private List<?> new202() /* reduce AAlistoflistterm1ListOfListTerm */
    {
        List<?> popped1 = pop();
        PListTerm pListTermNode1 = (PListTerm)popped1.get(0);
        List<PListTerm> listNode2;
        if(pListTermNode1 != null) {
            listNode2 = Collections.singletonList(pListTermNode1);
        } else {
            listNode2 = Collections.emptyList();
        }
        return Collections.singletonList(listNode2);
    }

    private List<?> new203() /* reduce AAlistoflistterm2ListOfListTerm */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        PListTerm pListTermNode1 = (PListTerm)popped1.get(0);
        List<PListTerm> listNode2 = (List<PListTerm>)popped2.get(0);
        List<PListTerm> listNode3 = new LinkedList<>();
        if(pListTermNode1 != null)
        {
            listNode3.add(pListTermNode1);
        }
        if (listNode3.isEmpty() && listNode2 instanceof LinkedList<?>) {
            listNode3 = listNode2;
        } else {
            listNode3.addAll(listNode2);
        }
        return Collections.singletonList(listNode3);
    }

    private List<?> new204() /* reduce AAnewlistterm1ListTerm */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PProdName pProdNameNode2 = (PProdName)popped2.get(0);
        TLPar tLParNode3 = (TLPar)popped3.get(0);
        ANewListTerm pListTermNode1 = new ANewListTerm(pProdNameNode2, tLParNode3, Collections.emptyList());
        computePositions(pListTermNode1, popped1, popped4);

        return Collections.singletonList(pListTermNode1);
    }

    private List<?> new205() /* reduce AAnewlistterm2ListTerm */
    {
        List<?> popped5 = pop();
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PProdName pProdNameNode2 = (PProdName)popped2.get(0);
        TLPar tLParNode3 = (TLPar)popped3.get(0);
        List<PTerm> listNode4 = (List<PTerm>)popped4.get(0);
        List<PTerm> listNode5 = listNode4;
        ANewListTerm pListTermNode1 = new ANewListTerm(pProdNameNode2, tLParNode3, listNode5);
        computePositions(pListTermNode1, popped1, popped5);

        return Collections.singletonList(pListTermNode1);
    }

    private List<?> new206() /* reduce AAsimplelistterm1ListTerm */
    {
        List<?> popped1 = pop();

        TId tIdNode3 = (TId)popped1.get(0);
        ASimpleListTerm pListTermNode1 = new ASimpleListTerm(null, tIdNode3, null);
        computePositions(pListTermNode1, popped1, popped1);

        return Collections.singletonList(pListTermNode1);
    }

    private List<?> new207() /* reduce AAsimplelistterm2ListTerm */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PSpecifier pSpecifierNode2 = (PSpecifier)popped1.get(0);
        TId tIdNode3 = (TId)popped2.get(0);
        ASimpleListTerm pListTermNode1 = new ASimpleListTerm(pSpecifierNode2, tIdNode3, null);
        computePositions(pListTermNode1, popped1, popped2);

        return Collections.singletonList(pListTermNode1);
    }

    private List<?> new208() /* reduce AAsimplelistterm3ListTerm */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        TId tIdNode3 = (TId)popped1.get(0);
        TId tIdNode4 = (TId)popped2.get(0);
        ASimpleListTerm pListTermNode1 = new ASimpleListTerm(null, tIdNode3, tIdNode4);
        computePositions(pListTermNode1, popped1, popped2);

        return Collections.singletonList(pListTermNode1);
    }

    private List<?> new209() /* reduce AAsimplelistterm4ListTerm */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PSpecifier pSpecifierNode2 = (PSpecifier)popped1.get(0);
        TId tIdNode3 = (TId)popped2.get(0);
        TId tIdNode4 = (TId)popped3.get(0);
        ASimpleListTerm pListTermNode1 = new ASimpleListTerm(pSpecifierNode2, tIdNode3, tIdNode4);
        computePositions(pListTermNode1, popped1, popped3);

        return Collections.singletonList(pListTermNode1);
    }

    private List<?> new210() /* reduce AListTermTail */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        PListTerm pListTermNode1 = (PListTerm)popped2.get(0);
        return Collections.singletonList(pListTermNode1);
    }

    private List<?> new211() /* reduce ASimpleTermTail */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        TId tIdNode1 = (TId)popped2.get(0);
        return Collections.singletonList(tIdNode1);
    }

    private List<?> new212() /* reduce AAprodname1ProdName */
    {
        List<?> popped1 = pop();

        TId tIdNode2 = (TId)popped1.get(0);
        AProdName pProdNameNode1 = new AProdName(tIdNode2, null);
        computePositions(pProdNameNode1, popped1, popped1);

        return Collections.singletonList(pProdNameNode1);
    }

    private List<?> new213() /* reduce AAprodname2ProdName */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        TId tIdNode2 = (TId)popped1.get(0);
        TId tIdNode3 = (TId)popped2.get(0);
        AProdName pProdNameNode1 = new AProdName(tIdNode2, tIdNode3);
        computePositions(pProdNameNode1, popped1, popped2);

        return Collections.singletonList(pProdNameNode1);
    }

    private List<?> new214() /* reduce AProdNameTail */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        TId tIdNode1 = (TId)popped2.get(0);
        return Collections.singletonList(tIdNode1);
    }

    private List<?> new215() /* reduce AAparams1Params */
    {
        List<?> popped1 = pop();
        PTerm pTermNode1 = (PTerm)popped1.get(0);
        List<PTerm> listNode2;
        if(pTermNode1 != null) {
            listNode2 = Collections.singletonList(pTermNode1);
        } else {
            listNode2 = Collections.emptyList();
        }
        return Collections.singletonList(listNode2);
    }

    private List<?> new216() /* reduce AAparams2Params */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        PTerm pTermNode1 = (PTerm)popped1.get(0);
        List<PTerm> listNode2 = (List<PTerm>)popped2.get(0);
        List<PTerm> listNode3 = new LinkedList<>();
        if(pTermNode1 != null)
        {
            listNode3.add(pTermNode1);
        }
        if (listNode3.isEmpty() && listNode2 instanceof LinkedList<?>) {
            listNode3 = listNode2;
        } else {
            listNode3.addAll(listNode2);
        }
        return Collections.singletonList(listNode3);
    }

    private List<?> new217() /* reduce AParamsTail */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        PTerm pTermNode1 = (PTerm)popped2.get(0);
        return Collections.singletonList(pTermNode1);
    }

    private List<?> new218() /* reduce AAltName */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        TId tIdNode1 = (TId)popped2.get(0);
        return Collections.singletonList(tIdNode1);
    }

    private List<?> new219() /* reduce AAelem1Elem */
    {
        List<?> popped1 = pop();

        TId tIdNode4 = (TId)popped1.get(0);
        AElem pElemNode1 = new AElem(null, null, tIdNode4, null);
        computePositions(pElemNode1, popped1, popped1);

        return Collections.singletonList(pElemNode1);
    }

    private List<?> new220() /* reduce AAelem2Elem */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        TId tIdNode2 = (TId)popped1.get(0);
        TId tIdNode4 = (TId)popped2.get(0);
        AElem pElemNode1 = new AElem(tIdNode2, null, tIdNode4, null);
        computePositions(pElemNode1, popped1, popped2);

        return Collections.singletonList(pElemNode1);
    }

    private List<?> new221() /* reduce AAelem3Elem */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PSpecifier pSpecifierNode3 = (PSpecifier)popped1.get(0);
        TId tIdNode4 = (TId)popped2.get(0);
        AElem pElemNode1 = new AElem(null, pSpecifierNode3, tIdNode4, null);
        computePositions(pElemNode1, popped1, popped2);

        return Collections.singletonList(pElemNode1);
    }

    private List<?> new222() /* reduce AAelem4Elem */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        TId tIdNode2 = (TId)popped1.get(0);
        PSpecifier pSpecifierNode3 = (PSpecifier)popped2.get(0);
        TId tIdNode4 = (TId)popped3.get(0);
        AElem pElemNode1 = new AElem(tIdNode2, pSpecifierNode3, tIdNode4, null);
        computePositions(pElemNode1, popped1, popped3);

        return Collections.singletonList(pElemNode1);
    }

    private List<?> new223() /* reduce AAelem5Elem */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        TId tIdNode4 = (TId)popped1.get(0);
        PUnOp pUnOpNode5 = (PUnOp)popped2.get(0);
        AElem pElemNode1 = new AElem(null, null, tIdNode4, pUnOpNode5);
        computePositions(pElemNode1, popped1, popped2);

        return Collections.singletonList(pElemNode1);
    }

    private List<?> new224() /* reduce AAelem6Elem */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        TId tIdNode2 = (TId)popped1.get(0);
        TId tIdNode4 = (TId)popped2.get(0);
        PUnOp pUnOpNode5 = (PUnOp)popped3.get(0);
        AElem pElemNode1 = new AElem(tIdNode2, null, tIdNode4, pUnOpNode5);
        computePositions(pElemNode1, popped1, popped3);

        return Collections.singletonList(pElemNode1);
    }

    private List<?> new225() /* reduce AAelem7Elem */
    {
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        PSpecifier pSpecifierNode3 = (PSpecifier)popped1.get(0);
        TId tIdNode4 = (TId)popped2.get(0);
        PUnOp pUnOpNode5 = (PUnOp)popped3.get(0);
        AElem pElemNode1 = new AElem(null, pSpecifierNode3, tIdNode4, pUnOpNode5);
        computePositions(pElemNode1, popped1, popped3);

        return Collections.singletonList(pElemNode1);
    }

    private List<?> new226() /* reduce AAelem8Elem */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        TId tIdNode2 = (TId)popped1.get(0);
        PSpecifier pSpecifierNode3 = (PSpecifier)popped2.get(0);
        TId tIdNode4 = (TId)popped3.get(0);
        PUnOp pUnOpNode5 = (PUnOp)popped4.get(0);
        AElem pElemNode1 = new AElem(tIdNode2, pSpecifierNode3, tIdNode4, pUnOpNode5);
        computePositions(pElemNode1, popped1, popped4);

        return Collections.singletonList(pElemNode1);
    }

    private List<?> new227() /* reduce AElemName */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        TId tIdNode1 = (TId)popped2.get(0);
        return Collections.singletonList(tIdNode1);
    }

    private List<?> new228() /* reduce ATokenSpecifier */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        ATokenSpecifier pSpecifierNode1 = new ATokenSpecifier();
        computePositions(pSpecifierNode1, popped1, popped2);

        return Collections.singletonList(pSpecifierNode1);
    }

    private List<?> new229() /* reduce AProductionSpecifier */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        AProductionSpecifier pSpecifierNode1 = new AProductionSpecifier();
        computePositions(pSpecifierNode1, popped1, popped2);

        return Collections.singletonList(pSpecifierNode1);
    }

    private List<?> new230() /* reduce AAst */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        List<PAstProd> listNode2 = (List<PAstProd>)popped4.get(0);
        List<PAstProd> listNode3 = listNode2;
        AAst pAstNode1 = new AAst(listNode3);
        computePositions(pAstNode1, popped1, popped4);

        return Collections.singletonList(pAstNode1);
    }

    private List<?> new231() /* reduce AAstProd */
    {
        List<?> popped4 = pop();
        List<?> popped3 = pop();
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        TId tIdNode2 = (TId)popped1.get(0);
        List<PAstAlt> listNode3 = (List<PAstAlt>)popped3.get(0);
        List<PAstAlt> listNode4 = listNode3;
        AAstProd pAstProdNode1 = new AAstProd(tIdNode2, listNode4);
        computePositions(pAstProdNode1, popped1, popped4);

        return Collections.singletonList(pAstProdNode1);
    }

    private List<?> new232() /* reduce AAastalts1AstAlts */
    {
        List<?> popped1 = pop();
        PAstAlt pAstAltNode1 = (PAstAlt)popped1.get(0);
        List<PAstAlt> listNode2;
        if(pAstAltNode1 != null) {
            listNode2 = Collections.singletonList(pAstAltNode1);
        } else {
            listNode2 = Collections.emptyList();
        }
        return Collections.singletonList(listNode2);
    }

    private List<?> new233() /* reduce AAastalts2AstAlts */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        PAstAlt pAstAltNode1 = (PAstAlt)popped1.get(0);
        List<PAstAlt> listNode2 = (List<PAstAlt>)popped2.get(0);
        List<PAstAlt> listNode3 = new LinkedList<>();
        if(pAstAltNode1 != null)
        {
            listNode3.add(pAstAltNode1);
        }
        if (listNode3.isEmpty() && listNode2 instanceof LinkedList<?>) {
            listNode3 = listNode2;
        } else {
            listNode3.addAll(listNode2);
        }
        return Collections.singletonList(listNode3);
    }

    private List<?> new234() /* reduce AAstAltsTail */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        PAstAlt pAstAltNode1 = (PAstAlt)popped2.get(0);
        return Collections.singletonList(pAstAltNode1);
    }

    private List<?> new235() /* reduce AAastalt1AstAlt */
    {

        AAstAlt pAstAltNode1 = new AAstAlt(null, Collections.emptyList());

        return Collections.singletonList(pAstAltNode1);
    }

    private List<?> new236() /* reduce AAastalt2AstAlt */
    {
        List<?> popped1 = pop();

        TId tIdNode2 = (TId)popped1.get(0);
        AAstAlt pAstAltNode1 = new AAstAlt(tIdNode2, Collections.emptyList());
        computePositions(pAstAltNode1, popped1, popped1);

        return Collections.singletonList(pAstAltNode1);
    }

    private List<?> new237() /* reduce AAastalt3AstAlt */
    {
        List<?> popped1 = pop();

        List<PElem> listNode3 = (List<PElem>)popped1.get(0);
        List<PElem> listNode4 = listNode3;
        AAstAlt pAstAltNode1 = new AAstAlt(null, listNode4);
        computePositions(pAstAltNode1, popped1, popped1);

        return Collections.singletonList(pAstAltNode1);
    }

    private List<?> new238() /* reduce AAastalt4AstAlt */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();

        TId tIdNode2 = (TId)popped1.get(0);
        List<PElem> listNode3 = (List<PElem>)popped2.get(0);
        List<PElem> listNode4 = listNode3;
        AAstAlt pAstAltNode1 = new AAstAlt(tIdNode2, listNode4);
        computePositions(pAstAltNode1, popped1, popped2);

        return Collections.singletonList(pAstAltNode1);
    }

    private List<?> new239() /* reduce ATerminal$PkgNameTail */
    {
        List<?> popped1 = pop();
        TPkgId tPkgIdNode1 = (TPkgId)popped1.get(0);
        List<TPkgId> listNode2;
        if(tPkgIdNode1 != null) {
            listNode2 = Collections.singletonList(tPkgIdNode1);
        } else {
            listNode2 = Collections.emptyList();
        }
        return Collections.singletonList(listNode2);
    }

    private List<?> new240() /* reduce ANonTerminal$PkgNameTail */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        List<TPkgId> listNode1 = (List<TPkgId>)popped1.get(0);
        TPkgId tPkgIdNode2 = (TPkgId)popped2.get(0);
        List<TPkgId> listNode3;
        if (listNode1 instanceof LinkedList<?>) {
            listNode3 = listNode1;
        } else {
            listNode3 = new LinkedList<>(listNode1);
        }
        if(tPkgIdNode2 != null)
        {
            listNode3.add(tPkgIdNode2);
        }
        return Collections.singletonList(listNode3);
    }

    private List<?> new241() /* reduce ATerminal$HelperDef */
    {
        List<?> popped1 = pop();
        PHelperDef pHelperDefNode1 = (PHelperDef)popped1.get(0);
        List<PHelperDef> listNode2;
        if(pHelperDefNode1 != null) {
            listNode2 = Collections.singletonList(pHelperDefNode1);
        } else {
            listNode2 = Collections.emptyList();
        }
        return Collections.singletonList(listNode2);
    }

    private List<?> new242() /* reduce ANonTerminal$HelperDef */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        List<PHelperDef> listNode1 = (List<PHelperDef>)popped1.get(0);
        PHelperDef pHelperDefNode2 = (PHelperDef)popped2.get(0);
        List<PHelperDef> listNode3;
        if (listNode1 instanceof LinkedList<?>) {
            listNode3 = listNode1;
        } else {
            listNode3 = new LinkedList<>(listNode1);
        }
        if(pHelperDefNode2 != null)
        {
            listNode3.add(pHelperDefNode2);
        }
        return Collections.singletonList(listNode3);
    }

    private List<?> new243() /* reduce ATerminal$IdListTail */
    {
        List<?> popped1 = pop();
        TId tIdNode1 = (TId)popped1.get(0);
        List<TId> listNode2;
        if(tIdNode1 != null) {
            listNode2 = Collections.singletonList(tIdNode1);
        } else {
            listNode2 = Collections.emptyList();
        }
        return Collections.singletonList(listNode2);
    }

    private List<?> new244() /* reduce ANonTerminal$IdListTail */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        List<TId> listNode1 = (List<TId>)popped1.get(0);
        TId tIdNode2 = (TId)popped2.get(0);
        List<TId> listNode3;
        if (listNode1 instanceof LinkedList<?>) {
            listNode3 = listNode1;
        } else {
            listNode3 = new LinkedList<>(listNode1);
        }
        if(tIdNode2 != null)
        {
            listNode3.add(tIdNode2);
        }
        return Collections.singletonList(listNode3);
    }

    private List<?> new245() /* reduce ATerminal$TokenDef */
    {
        List<?> popped1 = pop();
        PTokenDef pTokenDefNode1 = (PTokenDef)popped1.get(0);
        List<PTokenDef> listNode2;
        if(pTokenDefNode1 != null) {
            listNode2 = Collections.singletonList(pTokenDefNode1);
        } else {
            listNode2 = Collections.emptyList();
        }
        return Collections.singletonList(listNode2);
    }

    private List<?> new246() /* reduce ANonTerminal$TokenDef */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        List<PTokenDef> listNode1 = (List<PTokenDef>)popped1.get(0);
        PTokenDef pTokenDefNode2 = (PTokenDef)popped2.get(0);
        List<PTokenDef> listNode3;
        if (listNode1 instanceof LinkedList<?>) {
            listNode3 = listNode1;
        } else {
            listNode3 = new LinkedList<>(listNode1);
        }
        if(pTokenDefNode2 != null)
        {
            listNode3.add(pTokenDefNode2);
        }
        return Collections.singletonList(listNode3);
    }

    private List<?> new247() /* reduce ATerminal$StateListTail */
    {
        List<?> popped1 = pop();
        PStateListTail pStateListTailNode1 = (PStateListTail)popped1.get(0);
        List<PStateListTail> listNode2;
        if(pStateListTailNode1 != null) {
            listNode2 = Collections.singletonList(pStateListTailNode1);
        } else {
            listNode2 = Collections.emptyList();
        }
        return Collections.singletonList(listNode2);
    }

    private List<?> new248() /* reduce ANonTerminal$StateListTail */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        List<PStateListTail> listNode1 = (List<PStateListTail>)popped1.get(0);
        PStateListTail pStateListTailNode2 = (PStateListTail)popped2.get(0);
        List<PStateListTail> listNode3;
        if (listNode1 instanceof LinkedList<?>) {
            listNode3 = listNode1;
        } else {
            listNode3 = new LinkedList<>(listNode1);
        }
        if(pStateListTailNode2 != null)
        {
            listNode3.add(pStateListTailNode2);
        }
        return Collections.singletonList(listNode3);
    }

    private List<?> new249() /* reduce ATerminal$RegExpTail */
    {
        List<?> popped1 = pop();
        PConcat pConcatNode1 = (PConcat)popped1.get(0);
        List<PConcat> listNode2;
        if(pConcatNode1 != null) {
            listNode2 = Collections.singletonList(pConcatNode1);
        } else {
            listNode2 = Collections.emptyList();
        }
        return Collections.singletonList(listNode2);
    }

    private List<?> new250() /* reduce ANonTerminal$RegExpTail */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        List<PConcat> listNode1 = (List<PConcat>)popped1.get(0);
        PConcat pConcatNode2 = (PConcat)popped2.get(0);
        List<PConcat> listNode3;
        if (listNode1 instanceof LinkedList<?>) {
            listNode3 = listNode1;
        } else {
            listNode3 = new LinkedList<>(listNode1);
        }
        if(pConcatNode2 != null)
        {
            listNode3.add(pConcatNode2);
        }
        return Collections.singletonList(listNode3);
    }

    private List<?> new251() /* reduce ATerminal$UnExp */
    {
        List<?> popped1 = pop();
        PUnExp pUnExpNode1 = (PUnExp)popped1.get(0);
        List<PUnExp> listNode2;
        if(pUnExpNode1 != null) {
            listNode2 = Collections.singletonList(pUnExpNode1);
        } else {
            listNode2 = Collections.emptyList();
        }
        return Collections.singletonList(listNode2);
    }

    private List<?> new252() /* reduce ANonTerminal$UnExp */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        List<PUnExp> listNode1 = (List<PUnExp>)popped1.get(0);
        PUnExp pUnExpNode2 = (PUnExp)popped2.get(0);
        List<PUnExp> listNode3;
        if (listNode1 instanceof LinkedList<?>) {
            listNode3 = listNode1;
        } else {
            listNode3 = new LinkedList<>(listNode1);
        }
        if(pUnExpNode2 != null)
        {
            listNode3.add(pUnExpNode2);
        }
        return Collections.singletonList(listNode3);
    }

    private List<?> new253() /* reduce ATerminal$Prod */
    {
        List<?> popped1 = pop();
        PProd pProdNode1 = (PProd)popped1.get(0);
        List<PProd> listNode2;
        if(pProdNode1 != null) {
            listNode2 = Collections.singletonList(pProdNode1);
        } else {
            listNode2 = Collections.emptyList();
        }
        return Collections.singletonList(listNode2);
    }

    private List<?> new254() /* reduce ANonTerminal$Prod */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        List<PProd> listNode1 = (List<PProd>)popped1.get(0);
        PProd pProdNode2 = (PProd)popped2.get(0);
        List<PProd> listNode3;
        if (listNode1 instanceof LinkedList<?>) {
            listNode3 = listNode1;
        } else {
            listNode3 = new LinkedList<>(listNode1);
        }
        if(pProdNode2 != null)
        {
            listNode3.add(pProdNode2);
        }
        return Collections.singletonList(listNode3);
    }

    private List<?> new255() /* reduce ATerminal$Elem */
    {
        List<?> popped1 = pop();
        PElem pElemNode1 = (PElem)popped1.get(0);
        List<PElem> listNode2;
        if(pElemNode1 != null) {
            listNode2 = Collections.singletonList(pElemNode1);
        } else {
            listNode2 = Collections.emptyList();
        }
        return Collections.singletonList(listNode2);
    }

    private List<?> new256() /* reduce ANonTerminal$Elem */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        List<PElem> listNode1 = (List<PElem>)popped1.get(0);
        PElem pElemNode2 = (PElem)popped2.get(0);
        List<PElem> listNode3;
        if (listNode1 instanceof LinkedList<?>) {
            listNode3 = listNode1;
        } else {
            listNode3 = new LinkedList<>(listNode1);
        }
        if(pElemNode2 != null)
        {
            listNode3.add(pElemNode2);
        }
        return Collections.singletonList(listNode3);
    }

    private List<?> new257() /* reduce ATerminal$AltsTail */
    {
        List<?> popped1 = pop();
        PAlt pAltNode1 = (PAlt)popped1.get(0);
        List<PAlt> listNode2;
        if(pAltNode1 != null) {
            listNode2 = Collections.singletonList(pAltNode1);
        } else {
            listNode2 = Collections.emptyList();
        }
        return Collections.singletonList(listNode2);
    }

    private List<?> new258() /* reduce ANonTerminal$AltsTail */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        List<PAlt> listNode1 = (List<PAlt>)popped1.get(0);
        PAlt pAltNode2 = (PAlt)popped2.get(0);
        List<PAlt> listNode3;
        if (listNode1 instanceof LinkedList<?>) {
            listNode3 = listNode1;
        } else {
            listNode3 = new LinkedList<>(listNode1);
        }
        if(pAltNode2 != null)
        {
            listNode3.add(pAltNode2);
        }
        return Collections.singletonList(listNode3);
    }

    private List<?> new259() /* reduce ATerminal$Term */
    {
        List<?> popped1 = pop();
        PTerm pTermNode1 = (PTerm)popped1.get(0);
        List<PTerm> listNode2;
        if(pTermNode1 != null) {
            listNode2 = Collections.singletonList(pTermNode1);
        } else {
            listNode2 = Collections.emptyList();
        }
        return Collections.singletonList(listNode2);
    }

    private List<?> new260() /* reduce ANonTerminal$Term */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        List<PTerm> listNode1 = (List<PTerm>)popped1.get(0);
        PTerm pTermNode2 = (PTerm)popped2.get(0);
        List<PTerm> listNode3;
        if (listNode1 instanceof LinkedList<?>) {
            listNode3 = listNode1;
        } else {
            listNode3 = new LinkedList<>(listNode1);
        }
        if(pTermNode2 != null)
        {
            listNode3.add(pTermNode2);
        }
        return Collections.singletonList(listNode3);
    }

    private List<?> new261() /* reduce ATerminal$ListTermTail */
    {
        List<?> popped1 = pop();
        PListTerm pListTermNode1 = (PListTerm)popped1.get(0);
        List<PListTerm> listNode2;
        if(pListTermNode1 != null) {
            listNode2 = Collections.singletonList(pListTermNode1);
        } else {
            listNode2 = Collections.emptyList();
        }
        return Collections.singletonList(listNode2);
    }

    private List<?> new262() /* reduce ANonTerminal$ListTermTail */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        List<PListTerm> listNode1 = (List<PListTerm>)popped1.get(0);
        PListTerm pListTermNode2 = (PListTerm)popped2.get(0);
        List<PListTerm> listNode3;
        if (listNode1 instanceof LinkedList<?>) {
            listNode3 = listNode1;
        } else {
            listNode3 = new LinkedList<>(listNode1);
        }
        if(pListTermNode2 != null)
        {
            listNode3.add(pListTermNode2);
        }
        return Collections.singletonList(listNode3);
    }

    private List<?> new263() /* reduce ATerminal$ParamsTail */
    {
        List<?> popped1 = pop();
        PTerm pTermNode1 = (PTerm)popped1.get(0);
        List<PTerm> listNode2;
        if(pTermNode1 != null) {
            listNode2 = Collections.singletonList(pTermNode1);
        } else {
            listNode2 = Collections.emptyList();
        }
        return Collections.singletonList(listNode2);
    }

    private List<?> new264() /* reduce ANonTerminal$ParamsTail */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        List<PTerm> listNode1 = (List<PTerm>)popped1.get(0);
        PTerm pTermNode2 = (PTerm)popped2.get(0);
        List<PTerm> listNode3;
        if (listNode1 instanceof LinkedList<?>) {
            listNode3 = listNode1;
        } else {
            listNode3 = new LinkedList<>(listNode1);
        }
        if(pTermNode2 != null)
        {
            listNode3.add(pTermNode2);
        }
        return Collections.singletonList(listNode3);
    }

    private List<?> new265() /* reduce ATerminal$AstProd */
    {
        List<?> popped1 = pop();
        PAstProd pAstProdNode1 = (PAstProd)popped1.get(0);
        List<PAstProd> listNode2;
        if(pAstProdNode1 != null) {
            listNode2 = Collections.singletonList(pAstProdNode1);
        } else {
            listNode2 = Collections.emptyList();
        }
        return Collections.singletonList(listNode2);
    }

    private List<?> new266() /* reduce ANonTerminal$AstProd */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        List<PAstProd> listNode1 = (List<PAstProd>)popped1.get(0);
        PAstProd pAstProdNode2 = (PAstProd)popped2.get(0);
        List<PAstProd> listNode3;
        if (listNode1 instanceof LinkedList<?>) {
            listNode3 = listNode1;
        } else {
            listNode3 = new LinkedList<>(listNode1);
        }
        if(pAstProdNode2 != null)
        {
            listNode3.add(pAstProdNode2);
        }
        return Collections.singletonList(listNode3);
    }

    private List<?> new267() /* reduce ATerminal$AstAltsTail */
    {
        List<?> popped1 = pop();
        PAstAlt pAstAltNode1 = (PAstAlt)popped1.get(0);
        List<PAstAlt> listNode2;
        if(pAstAltNode1 != null) {
            listNode2 = Collections.singletonList(pAstAltNode1);
        } else {
            listNode2 = Collections.emptyList();
        }
        return Collections.singletonList(listNode2);
    }

    private List<?> new268() /* reduce ANonTerminal$AstAltsTail */
    {
        List<?> popped2 = pop();
        List<?> popped1 = pop();
        List<PAstAlt> listNode1 = (List<PAstAlt>)popped1.get(0);
        PAstAlt pAstAltNode2 = (PAstAlt)popped2.get(0);
        List<PAstAlt> listNode3;
        if (listNode1 instanceof LinkedList<?>) {
            listNode3 = listNode1;
        } else {
            listNode3 = new LinkedList<>(listNode1);
        }
        if(pAstAltNode2 != null)
        {
            listNode3.add(pAstAltNode2);
        }
        return Collections.singletonList(listNode3);
    }


    private static final int[][][] actionTable;
/*      {
            {{-1, REDUCE, 0}, {1, SHIFT, 1}, {2, SHIFT, 2}, {3, SHIFT, 3}, {4, SHIFT, 4}, {5, SHIFT, 5}, {6, SHIFT, 6}, {7, SHIFT, 7}, },
            {{-1, ERROR, 1}, {0, SHIFT, 16}, },
            {{-1, ERROR, 2}, {33, SHIFT, 18}, },
            {{-1, ERROR, 3}, {33, SHIFT, 20}, },
            {{-1, ERROR, 4}, {22, SHIFT, 23}, {33, SHIFT, 24}, },
            {{-1, ERROR, 5}, {4, SHIFT, 28}, },
            {{-1, ERROR, 6}, {33, SHIFT, 29}, },
            {{-1, ERROR, 7}, {8, SHIFT, 32}, },
            {{-1, ERROR, 8}, {38, ACCEPT, -1}, },
            {{-1, REDUCE, 1}, {2, SHIFT, 2}, {3, SHIFT, 3}, {4, SHIFT, 4}, {5, SHIFT, 5}, {6, SHIFT, 6}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 2}, {2, SHIFT, 2}, {4, SHIFT, 4}, {5, SHIFT, 5}, {6, SHIFT, 6}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 4}, {4, SHIFT, 4}, {5, SHIFT, 5}, {6, SHIFT, 6}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 8}, {5, SHIFT, 5}, {6, SHIFT, 6}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 16}, {6, SHIFT, 6}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 32}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 64}, },
            {{-1, ERROR, 16}, {14, SHIFT, 54}, {16, SHIFT, 55}, },
            {{-1, REDUCE, 128}, },
            {{-1, REDUCE, 135}, {29, SHIFT, 58}, },
            {{-1, ERROR, 19}, {16, SHIFT, 61}, },
            {{-1, ERROR, 20}, {17, SHIFT, 62}, },
            {{-1, REDUCE, 241}, },
            {{-1, REDUCE, 132}, {33, SHIFT, 20}, },
            {{-1, ERROR, 23}, {33, SHIFT, 64}, },
            {{-1, ERROR, 24}, {17, SHIFT, 65}, },
            {{-1, REDUCE, 245}, },
            {{-1, ERROR, 26}, {33, SHIFT, 66}, },
            {{-1, REDUCE, 138}, {22, SHIFT, 23}, {33, SHIFT, 24}, },
            {{-1, ERROR, 28}, {16, SHIFT, 68}, {33, SHIFT, 18}, },
            {{-1, ERROR, 29}, {17, SHIFT, 70}, {22, SHIFT, 71}, },
            {{-1, REDUCE, 253}, },
            {{-1, REDUCE, 175}, {33, SHIFT, 29}, },
            {{-1, ERROR, 32}, {9, SHIFT, 74}, },
            {{-1, REDUCE, 3}, {2, SHIFT, 2}, {4, SHIFT, 4}, {5, SHIFT, 5}, {6, SHIFT, 6}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 5}, {4, SHIFT, 4}, {5, SHIFT, 5}, {6, SHIFT, 6}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 9}, {5, SHIFT, 5}, {6, SHIFT, 6}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 17}, {6, SHIFT, 6}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 33}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 65}, },
            {{-1, REDUCE, 6}, {4, SHIFT, 4}, {5, SHIFT, 5}, {6, SHIFT, 6}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 10}, {5, SHIFT, 5}, {6, SHIFT, 6}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 18}, {6, SHIFT, 6}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 34}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 66}, },
            {{-1, REDUCE, 12}, {5, SHIFT, 5}, {6, SHIFT, 6}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 20}, {6, SHIFT, 6}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 36}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 68}, },
            {{-1, REDUCE, 24}, {6, SHIFT, 6}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 40}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 72}, },
            {{-1, REDUCE, 48}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 80}, },
            {{-1, REDUCE, 96}, },
            {{-1, ERROR, 54}, {0, SHIFT, 110}, },
            {{-1, REDUCE, 129}, },
            {{-1, REDUCE, 239}, },
            {{-1, ERROR, 57}, {14, SHIFT, 54}, {16, SHIFT, 111}, },
            {{-1, ERROR, 58}, {33, SHIFT, 113}, },
            {{-1, REDUCE, 243}, },
            {{-1, REDUCE, 136}, {29, SHIFT, 58}, },
            {{-1, REDUCE, 134}, },
            {{-1, REDUCE, 156}, {18, SHIFT, 115}, {20, SHIFT, 116}, {33, SHIFT, 117}, {34, SHIFT, 118}, {35, SHIFT, 119}, {36, SHIFT, 120}, {37, SHIFT, 121}, },
            {{-1, REDUCE, 242}, },
            {{-1, ERROR, 64}, {23, SHIFT, 129}, {29, SHIFT, 130}, {31, SHIFT, 131}, },
            {{-1, REDUCE, 156}, {18, SHIFT, 115}, {20, SHIFT, 116}, {33, SHIFT, 117}, {34, SHIFT, 118}, {35, SHIFT, 119}, {36, SHIFT, 120}, {37, SHIFT, 121}, },
            {{-1, ERROR, 66}, {17, SHIFT, 136}, },
            {{-1, REDUCE, 246}, },
            {{-1, REDUCE, 150}, },
            {{-1, ERROR, 69}, {16, SHIFT, 137}, },
            {{-1, REDUCE, 183}, {12, SHIFT, 138}, {13, SHIFT, 139}, {18, SHIFT, 140}, {22, SHIFT, 141}, {33, SHIFT, 142}, },
            {{-1, ERROR, 71}, {31, SHIFT, 151}, },
            {{-1, ERROR, 72}, {17, SHIFT, 152}, },
            {{-1, REDUCE, 254}, },
            {{-1, ERROR, 74}, {33, SHIFT, 153}, },
            {{-1, REDUCE, 7}, {4, SHIFT, 4}, {5, SHIFT, 5}, {6, SHIFT, 6}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 11}, {5, SHIFT, 5}, {6, SHIFT, 6}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 19}, {6, SHIFT, 6}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 35}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 67}, },
            {{-1, REDUCE, 13}, {5, SHIFT, 5}, {6, SHIFT, 6}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 21}, {6, SHIFT, 6}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 37}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 69}, },
            {{-1, REDUCE, 25}, {6, SHIFT, 6}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 41}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 73}, },
            {{-1, REDUCE, 49}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 81}, },
            {{-1, REDUCE, 97}, },
            {{-1, REDUCE, 14}, {5, SHIFT, 5}, {6, SHIFT, 6}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 22}, {6, SHIFT, 6}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 38}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 70}, },
            {{-1, REDUCE, 26}, {6, SHIFT, 6}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 42}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 74}, },
            {{-1, REDUCE, 50}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 82}, },
            {{-1, REDUCE, 98}, },
            {{-1, REDUCE, 28}, {6, SHIFT, 6}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 44}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 76}, },
            {{-1, REDUCE, 52}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 84}, },
            {{-1, REDUCE, 100}, },
            {{-1, REDUCE, 56}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 88}, },
            {{-1, REDUCE, 104}, },
            {{-1, REDUCE, 112}, },
            {{-1, REDUCE, 131}, },
            {{-1, REDUCE, 130}, },
            {{-1, REDUCE, 240}, },
            {{-1, REDUCE, 137}, },
            {{-1, REDUCE, 244}, },
            {{-1, ERROR, 115}, {18, SHIFT, 115}, {20, SHIFT, 116}, {33, SHIFT, 117}, {34, SHIFT, 118}, {35, SHIFT, 119}, {36, SHIFT, 120}, {37, SHIFT, 121}, },
            {{-1, REDUCE, 156}, {18, SHIFT, 115}, {20, SHIFT, 116}, {33, SHIFT, 117}, {34, SHIFT, 118}, {35, SHIFT, 119}, {36, SHIFT, 120}, {37, SHIFT, 121}, },
            {{-1, REDUCE, 163}, },
            {{-1, REDUCE, 165}, },
            {{-1, REDUCE, 166}, },
            {{-1, REDUCE, 167}, },
            {{-1, REDUCE, 162}, },
            {{-1, ERROR, 122}, {16, SHIFT, 194}, },
            {{-1, REDUCE, 153}, {28, SHIFT, 195}, },
            {{-1, REDUCE, 251}, },
            {{-1, REDUCE, 158}, {24, SHIFT, 198}, {26, SHIFT, 199}, {27, SHIFT, 200}, },
            {{-1, REDUCE, 160}, },
            {{-1, REDUCE, 161}, },
            {{-1, REDUCE, 157}, {18, SHIFT, 115}, {20, SHIFT, 116}, {33, SHIFT, 117}, {34, SHIFT, 118}, {35, SHIFT, 119}, {36, SHIFT, 120}, {37, SHIFT, 121}, },
            {{-1, REDUCE, 143}, },
            {{-1, ERROR, 130}, {33, SHIFT, 203}, },
            {{-1, ERROR, 131}, {33, SHIFT, 204}, },
            {{-1, REDUCE, 247}, },
            {{-1, ERROR, 133}, {23, SHIFT, 205}, {29, SHIFT, 130}, },
            {{-1, ERROR, 134}, {23, SHIFT, 207}, {29, SHIFT, 130}, },
            {{-1, ERROR, 135}, {16, SHIFT, 209}, {30, SHIFT, 210}, },
            {{-1, REDUCE, 156}, {18, SHIFT, 115}, {20, SHIFT, 116}, {33, SHIFT, 117}, {34, SHIFT, 118}, {35, SHIFT, 119}, {36, SHIFT, 120}, {37, SHIFT, 121}, },
            {{-1, REDUCE, 151}, },
            {{-1, ERROR, 138}, {14, SHIFT, 213}, },
            {{-1, ERROR, 139}, {14, SHIFT, 214}, },
            {{-1, ERROR, 140}, {33, SHIFT, 215}, },
            {{-1, ERROR, 141}, {31, SHIFT, 216}, {33, SHIFT, 217}, },
            {{-1, REDUCE, 219}, {24, SHIFT, 198}, {26, SHIFT, 199}, {27, SHIFT, 200}, },
            {{-1, ERROR, 143}, {16, SHIFT, 219}, },
            {{-1, REDUCE, 180}, {28, SHIFT, 220}, },
            {{-1, REDUCE, 187}, },
            {{-1, REDUCE, 184}, {12, SHIFT, 138}, {13, SHIFT, 139}, {18, SHIFT, 140}, {22, SHIFT, 223}, {33, SHIFT, 142}, },
            {{-1, REDUCE, 255}, },
            {{-1, ERROR, 148}, {12, SHIFT, 138}, {13, SHIFT, 139}, {33, SHIFT, 226}, },
            {{-1, ERROR, 149}, {33, SHIFT, 228}, },
            {{-1, REDUCE, 185}, {12, SHIFT, 138}, {13, SHIFT, 139}, {18, SHIFT, 140}, {22, SHIFT, 223}, {33, SHIFT, 142}, },
            {{-1, ERROR, 151}, {12, SHIFT, 138}, {13, SHIFT, 139}, {18, SHIFT, 140}, {23, SHIFT, 231}, {33, SHIFT, 142}, },
            {{-1, REDUCE, 183}, {12, SHIFT, 138}, {13, SHIFT, 139}, {18, SHIFT, 140}, {22, SHIFT, 141}, {33, SHIFT, 142}, },
            {{-1, ERROR, 153}, {17, SHIFT, 234}, },
            {{-1, REDUCE, 265}, },
            {{-1, REDUCE, 230}, {33, SHIFT, 153}, },
            {{-1, REDUCE, 15}, {5, SHIFT, 5}, {6, SHIFT, 6}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 23}, {6, SHIFT, 6}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 39}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 71}, },
            {{-1, REDUCE, 27}, {6, SHIFT, 6}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 43}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 75}, },
            {{-1, REDUCE, 51}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 83}, },
            {{-1, REDUCE, 99}, },
            {{-1, REDUCE, 29}, {6, SHIFT, 6}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 45}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 77}, },
            {{-1, REDUCE, 53}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 85}, },
            {{-1, REDUCE, 101}, },
            {{-1, REDUCE, 57}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 89}, },
            {{-1, REDUCE, 105}, },
            {{-1, REDUCE, 113}, },
            {{-1, REDUCE, 30}, {6, SHIFT, 6}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 46}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 78}, },
            {{-1, REDUCE, 54}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 86}, },
            {{-1, REDUCE, 102}, },
            {{-1, REDUCE, 58}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 90}, },
            {{-1, REDUCE, 106}, },
            {{-1, REDUCE, 114}, },
            {{-1, REDUCE, 60}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 92}, },
            {{-1, REDUCE, 108}, },
            {{-1, REDUCE, 116}, },
            {{-1, REDUCE, 120}, },
            {{-1, ERROR, 191}, {24, SHIFT, 257}, {25, SHIFT, 258}, },
            {{-1, REDUCE, 160}, {15, SHIFT, 260}, },
            {{-1, ERROR, 193}, {21, SHIFT, 261}, },
            {{-1, REDUCE, 133}, },
            {{-1, REDUCE, 156}, {18, SHIFT, 115}, {20, SHIFT, 116}, {33, SHIFT, 117}, {34, SHIFT, 118}, {35, SHIFT, 119}, {36, SHIFT, 120}, {37, SHIFT, 121}, },
            {{-1, REDUCE, 249}, },
            {{-1, REDUCE, 154}, {28, SHIFT, 195}, },
            {{-1, REDUCE, 172}, },
            {{-1, REDUCE, 171}, },
            {{-1, REDUCE, 170}, },
            {{-1, REDUCE, 159}, },
            {{-1, REDUCE, 252}, },
            {{-1, REDUCE, 147}, {31, SHIFT, 131}, },
            {{-1, REDUCE, 149}, },
            {{-1, REDUCE, 144}, },
            {{-1, ERROR, 206}, {23, SHIFT, 265}, {29, SHIFT, 130}, },
            {{-1, REDUCE, 145}, },
            {{-1, REDUCE, 248}, },
            {{-1, REDUCE, 139}, },
            {{-1, REDUCE, 156}, {18, SHIFT, 115}, {20, SHIFT, 116}, {33, SHIFT, 117}, {34, SHIFT, 118}, {35, SHIFT, 119}, {36, SHIFT, 120}, {37, SHIFT, 121}, },
            {{-1, ERROR, 211}, {16, SHIFT, 267}, },
            {{-1, ERROR, 212}, {16, SHIFT, 268}, {30, SHIFT, 210}, },
            {{-1, REDUCE, 228}, },
            {{-1, REDUCE, 229}, },
            {{-1, ERROR, 215}, {19, SHIFT, 270}, },
            {{-1, ERROR, 216}, {10, SHIFT, 271}, {11, SHIFT, 272}, {12, SHIFT, 138}, {13, SHIFT, 139}, {18, SHIFT, 273}, {23, SHIFT, 274}, {33, SHIFT, 275}, },
            {{-1, ERROR, 217}, {23, SHIFT, 279}, },
            {{-1, REDUCE, 223}, },
            {{-1, REDUCE, 176}, },
            {{-1, REDUCE, 183}, {12, SHIFT, 138}, {13, SHIFT, 139}, {18, SHIFT, 140}, {22, SHIFT, 141}, {33, SHIFT, 142}, },
            {{-1, REDUCE, 257}, },
            {{-1, REDUCE, 181}, {28, SHIFT, 220}, },
            {{-1, ERROR, 223}, {31, SHIFT, 216}, },
            {{-1, REDUCE, 188}, },
            {{-1, REDUCE, 186}, {12, SHIFT, 138}, {13, SHIFT, 139}, {18, SHIFT, 140}, {22, SHIFT, 223}, {33, SHIFT, 142}, },
            {{-1, REDUCE, 220}, {24, SHIFT, 198}, {26, SHIFT, 199}, {27, SHIFT, 200}, },
            {{-1, ERROR, 227}, {33, SHIFT, 284}, },
            {{-1, REDUCE, 221}, {24, SHIFT, 198}, {26, SHIFT, 199}, {27, SHIFT, 200}, },
            {{-1, REDUCE, 189}, },
            {{-1, REDUCE, 256}, },
            {{-1, REDUCE, 178}, },
            {{-1, ERROR, 232}, {12, SHIFT, 138}, {13, SHIFT, 139}, {18, SHIFT, 140}, {23, SHIFT, 286}, {33, SHIFT, 142}, },
            {{-1, ERROR, 233}, {16, SHIFT, 287}, },
            {{-1, REDUCE, 235}, {12, SHIFT, 138}, {13, SHIFT, 139}, {18, SHIFT, 140}, {22, SHIFT, 288}, {33, SHIFT, 142}, },
            {{-1, REDUCE, 266}, },
            {{-1, REDUCE, 31}, {6, SHIFT, 6}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 47}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 79}, },
            {{-1, REDUCE, 55}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 87}, },
            {{-1, REDUCE, 103}, },
            {{-1, REDUCE, 59}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 91}, },
            {{-1, REDUCE, 107}, },
            {{-1, REDUCE, 115}, },
            {{-1, REDUCE, 61}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 93}, },
            {{-1, REDUCE, 109}, },
            {{-1, REDUCE, 117}, },
            {{-1, REDUCE, 121}, },
            {{-1, REDUCE, 62}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 94}, },
            {{-1, REDUCE, 110}, },
            {{-1, REDUCE, 118}, },
            {{-1, REDUCE, 122}, },
            {{-1, REDUCE, 124}, },
            {{-1, REDUCE, 173}, },
            {{-1, REDUCE, 174}, },
            {{-1, ERROR, 259}, {18, SHIFT, 115}, {20, SHIFT, 116}, {33, SHIFT, 117}, {34, SHIFT, 118}, {35, SHIFT, 119}, {36, SHIFT, 120}, {37, SHIFT, 121}, },
            {{-1, ERROR, 260}, {34, SHIFT, 118}, {35, SHIFT, 119}, {36, SHIFT, 120}, },
            {{-1, REDUCE, 164}, },
            {{-1, REDUCE, 155}, },
            {{-1, REDUCE, 250}, },
            {{-1, REDUCE, 148}, },
            {{-1, REDUCE, 146}, },
            {{-1, REDUCE, 152}, },
            {{-1, REDUCE, 141}, },
            {{-1, REDUCE, 140}, },
            {{-1, ERROR, 269}, {16, SHIFT, 302}, },
            {{-1, ERROR, 270}, {32, SHIFT, 303}, },
            {{-1, ERROR, 271}, {33, SHIFT, 304}, },
            {{-1, REDUCE, 201}, },
            {{-1, ERROR, 273}, {10, SHIFT, 306}, {12, SHIFT, 138}, {13, SHIFT, 139}, {19, SHIFT, 307}, {33, SHIFT, 308}, },
            {{-1, REDUCE, 191}, },
            {{-1, REDUCE, 197}, {14, SHIFT, 312}, },
            {{-1, REDUCE, 259}, },
            {{-1, ERROR, 277}, {33, SHIFT, 314}, },
            {{-1, ERROR, 278}, {10, SHIFT, 271}, {11, SHIFT, 272}, {12, SHIFT, 138}, {13, SHIFT, 139}, {18, SHIFT, 273}, {23, SHIFT, 315}, {33, SHIFT, 275}, },
            {{-1, REDUCE, 218}, },
            {{-1, REDUCE, 182}, },
            {{-1, REDUCE, 258}, },
            {{-1, REDUCE, 190}, },
            {{-1, REDUCE, 224}, },
            {{-1, REDUCE, 222}, {24, SHIFT, 198}, {26, SHIFT, 199}, {27, SHIFT, 200}, },
            {{-1, REDUCE, 225}, },
            {{-1, REDUCE, 179}, },
            {{-1, REDUCE, 177}, },
            {{-1, ERROR, 288}, {33, SHIFT, 217}, },
            {{-1, REDUCE, 236}, {12, SHIFT, 138}, {13, SHIFT, 139}, {18, SHIFT, 140}, {33, SHIFT, 142}, },
            {{-1, ERROR, 290}, {16, SHIFT, 319}, },
            {{-1, REDUCE, 232}, {28, SHIFT, 320}, },
            {{-1, REDUCE, 237}, {12, SHIFT, 138}, {13, SHIFT, 139}, {18, SHIFT, 140}, {33, SHIFT, 142}, },
            {{-1, REDUCE, 63}, {7, SHIFT, 7}, },
            {{-1, REDUCE, 95}, },
            {{-1, REDUCE, 111}, },
            {{-1, REDUCE, 119}, },
            {{-1, REDUCE, 123}, },
            {{-1, REDUCE, 125}, },
            {{-1, REDUCE, 126}, },
            {{-1, ERROR, 300}, {19, SHIFT, 324}, },
            {{-1, ERROR, 301}, {19, SHIFT, 325}, },
            {{-1, REDUCE, 142}, },
            {{-1, REDUCE, 227}, },
            {{-1, REDUCE, 212}, {14, SHIFT, 326}, },
            {{-1, ERROR, 305}, {20, SHIFT, 328}, },
            {{-1, ERROR, 306}, {33, SHIFT, 304}, },
            {{-1, REDUCE, 195}, },
            {{-1, REDUCE, 206}, {14, SHIFT, 312}, },
            {{-1, ERROR, 309}, {19, SHIFT, 331}, },
            {{-1, REDUCE, 202}, {29, SHIFT, 332}, },
            {{-1, ERROR, 311}, {33, SHIFT, 335}, },
            {{-1, ERROR, 312}, {33, SHIFT, 336}, },
            {{-1, REDUCE, 199}, },
            {{-1, REDUCE, 198}, {14, SHIFT, 312}, },
            {{-1, REDUCE, 192}, },
            {{-1, REDUCE, 260}, },
            {{-1, REDUCE, 226}, },
            {{-1, REDUCE, 238}, {12, SHIFT, 138}, {13, SHIFT, 139}, {18, SHIFT, 140}, {33, SHIFT, 142}, },
            {{-1, REDUCE, 231}, },
            {{-1, REDUCE, 235}, {12, SHIFT, 138}, {13, SHIFT, 139}, {18, SHIFT, 140}, {22, SHIFT, 288}, {33, SHIFT, 142}, },
            {{-1, REDUCE, 267}, },
            {{-1, REDUCE, 233}, {28, SHIFT, 320}, },
            {{-1, REDUCE, 127}, },
            {{-1, REDUCE, 168}, },
            {{-1, REDUCE, 169}, },
            {{-1, ERROR, 326}, {33, SHIFT, 340}, },
            {{-1, REDUCE, 213}, },
            {{-1, ERROR, 328}, {10, SHIFT, 271}, {11, SHIFT, 272}, {12, SHIFT, 138}, {13, SHIFT, 139}, {18, SHIFT, 273}, {21, SHIFT, 341}, {33, SHIFT, 275}, },
            {{-1, ERROR, 329}, {20, SHIFT, 344}, },
            {{-1, REDUCE, 208}, },
            {{-1, REDUCE, 196}, },
            {{-1, ERROR, 332}, {10, SHIFT, 306}, {12, SHIFT, 138}, {13, SHIFT, 139}, {33, SHIFT, 308}, },
            {{-1, REDUCE, 261}, },
            {{-1, REDUCE, 203}, {29, SHIFT, 332}, },
            {{-1, REDUCE, 207}, {14, SHIFT, 312}, },
            {{-1, REDUCE, 211}, },
            {{-1, REDUCE, 200}, },
            {{-1, REDUCE, 234}, },
            {{-1, REDUCE, 268}, },
            {{-1, REDUCE, 214}, },
            {{-1, REDUCE, 193}, },
            {{-1, REDUCE, 215}, {29, SHIFT, 348}, },
            {{-1, ERROR, 343}, {21, SHIFT, 351}, },
            {{-1, ERROR, 344}, {10, SHIFT, 271}, {11, SHIFT, 272}, {12, SHIFT, 138}, {13, SHIFT, 139}, {18, SHIFT, 273}, {21, SHIFT, 352}, {33, SHIFT, 275}, },
            {{-1, REDUCE, 210}, },
            {{-1, REDUCE, 262}, },
            {{-1, REDUCE, 209}, },
            {{-1, ERROR, 348}, {10, SHIFT, 271}, {11, SHIFT, 272}, {12, SHIFT, 138}, {13, SHIFT, 139}, {18, SHIFT, 273}, {33, SHIFT, 275}, },
            {{-1, REDUCE, 263}, },
            {{-1, REDUCE, 216}, {29, SHIFT, 348}, },
            {{-1, REDUCE, 194}, },
            {{-1, REDUCE, 204}, },
            {{-1, ERROR, 353}, {21, SHIFT, 356}, },
            {{-1, REDUCE, 217}, },
            {{-1, REDUCE, 264}, },
            {{-1, REDUCE, 205}, },
        };*/
    private static final int[][][] gotoTable;
/*      {
            {{-1, 8}, },
            {{-1, 9}, },
            {{-1, 17}, },
            {{-1, 56}, {57, 112}, },
            {{-1, 10}, {9, 33}, },
            {{-1, 21}, {22, 63}, },
            {{-1, 11}, {9, 34}, {10, 39}, {33, 75}, },
            {{-1, 19}, {28, 69}, },
            {{-1, 59}, {60, 114}, },
            {{-1, 12}, {9, 35}, {10, 40}, {11, 44}, {33, 76}, {34, 80}, {39, 90}, {75, 156}, },
            {{-1, 25}, {27, 67}, },
            {{-1, 26}, },
            {{-1, 132}, {134, 208}, {206, 208}, },
            {{-1, 133}, {203, 264}, },
            {{-1, 13}, {9, 36}, {10, 41}, {11, 45}, {12, 48}, {33, 77}, {34, 81}, {35, 84}, {39, 91}, {40, 94}, {44, 100}, {75, 157}, {76, 160}, {80, 166}, {90, 176}, {156, 236}, },
            {{-1, 211}, {212, 269}, },
            {{-1, 122}, {65, 135}, {116, 193}, {136, 212}, {210, 266}, },
            {{-1, 196}, {197, 263}, },
            {{-1, 123}, {195, 262}, },
            {{-1, 124}, {128, 202}, },
            {{-1, 125}, {115, 191}, {259, 300}, },
            {{-1, 126}, {115, 192}, {260, 301}, },
            {{-1, 127}, },
            {{-1, 201}, {142, 218}, {226, 283}, {228, 285}, {284, 317}, },
            {{-1, 259}, },
            {{-1, 14}, {9, 37}, {10, 42}, {11, 46}, {12, 49}, {13, 51}, {33, 78}, {34, 82}, {35, 85}, {36, 87}, {39, 92}, {40, 95}, {41, 97}, {44, 101}, {45, 103}, {48, 106}, {75, 158}, {76, 161}, {77, 163}, {80, 167}, {81, 169}, {84, 172}, {90, 177}, {91, 179}, {94, 182}, {100, 186}, {156, 237}, {157, 239}, {160, 242}, {166, 246}, {176, 251}, {236, 293}, },
            {{-1, 30}, {31, 73}, },
            {{-1, 72}, },
            {{-1, 143}, {152, 233}, },
            {{-1, 221}, {222, 281}, },
            {{-1, 144}, {220, 280}, },
            {{-1, 145}, {146, 224}, {150, 229}, {225, 282}, },
            {{-1, 342}, {216, 276}, {278, 316}, {348, 354}, },
            {{-1, 309}, },
            {{-1, 310}, {332, 345}, },
            {{-1, 333}, {334, 346}, },
            {{-1, 313}, {308, 330}, {314, 337}, {335, 347}, },
            {{-1, 305}, {306, 329}, },
            {{-1, 327}, },
            {{-1, 343}, {344, 353}, },
            {{-1, 349}, {350, 355}, },
            {{-1, 146}, {234, 289}, {320, 289}, },
            {{-1, 147}, {150, 230}, {225, 230}, {232, 230}, {292, 230}, {318, 230}, },
            {{-1, 148}, },
            {{-1, 149}, {148, 227}, {216, 277}, {273, 311}, {278, 277}, {328, 277}, {332, 311}, {344, 277}, {348, 277}, },
            {{-1, 15}, {9, 38}, {10, 43}, {11, 47}, {12, 50}, {13, 52}, {14, 53}, {33, 79}, {34, 83}, {35, 86}, {36, 88}, {37, 89}, {39, 93}, {40, 96}, {41, 98}, {42, 99}, {44, 102}, {45, 104}, {46, 105}, {48, 107}, {49, 108}, {51, 109}, {75, 159}, {76, 162}, {77, 164}, {78, 165}, {80, 168}, {81, 170}, {82, 171}, {84, 173}, {85, 174}, {87, 175}, {90, 178}, {91, 180}, {92, 181}, {94, 183}, {95, 184}, {97, 185}, {100, 187}, {101, 188}, {103, 189}, {106, 190}, {156, 238}, {157, 240}, {158, 241}, {160, 243}, {161, 244}, {163, 245}, {166, 247}, {167, 248}, {169, 249}, {172, 250}, {176, 252}, {177, 253}, {179, 254}, {182, 255}, {186, 256}, {236, 294}, {237, 295}, {239, 296}, {242, 297}, {246, 298}, {251, 299}, {293, 323}, },
            {{-1, 154}, {155, 235}, },
            {{-1, 290}, },
            {{-1, 321}, {322, 339}, },
            {{-1, 291}, {320, 338}, },
            {{-1, 57}, },
            {{-1, 22}, },
            {{-1, 60}, },
            {{-1, 27}, },
            {{-1, 134}, {133, 206}, },
            {{-1, 197}, },
            {{-1, 128}, },
            {{-1, 31}, },
            {{-1, 150}, {146, 225}, {151, 232}, {234, 292}, {289, 318}, {320, 292}, },
            {{-1, 222}, },
            {{-1, 278}, },
            {{-1, 334}, },
            {{-1, 350}, },
            {{-1, 155}, },
            {{-1, 322}, },
        };*/
    private static final String[] errorMessages;
/*      {
            "expecting: 'Package', 'States', 'Helpers', 'Tokens', 'Ignored', 'Productions', 'Abstract', EOF",
            "expecting: pkg id",
            "expecting: id",
            "expecting: '{', id",
            "expecting: 'Tokens'",
            "expecting: 'Syntax'",
            "expecting: EOF",
            "expecting: 'States', 'Helpers', 'Tokens', 'Ignored', 'Productions', 'Abstract', EOF",
            "expecting: 'States', 'Tokens', 'Ignored', 'Productions', 'Abstract', EOF",
            "expecting: 'Tokens', 'Ignored', 'Productions', 'Abstract', EOF",
            "expecting: 'Ignored', 'Productions', 'Abstract', EOF",
            "expecting: 'Productions', 'Abstract', EOF",
            "expecting: 'Abstract', EOF",
            "expecting: '.', ';'",
            "expecting: ';', ','",
            "expecting: ';'",
            "expecting: '='",
            "expecting: 'States', 'Tokens', 'Ignored', 'Productions', 'Abstract', id, EOF",
            "expecting: 'Ignored', 'Productions', 'Abstract', '{', id, EOF",
            "expecting: ';', id",
            "expecting: '=', '{'",
            "expecting: 'Abstract', id, EOF",
            "expecting: 'Tree'",
            "expecting: ';', '[', '(', '|', id, char, dec char, hex char, string",
            "expecting: '}', ',', '->'",
            "expecting: ';', '[', '(', '|', '/', id, char, dec char, hex char, string",
            "expecting: 'T', 'P', ';', '[', '{', '|', id",
            "expecting: '->'",
            "expecting: '[', '(', id, char, dec char, hex char, string",
            "expecting: '[', '(', ')', '|', id, char, dec char, hex char, string",
            "expecting: ';', '[', ']', '(', ')', '+', '-', '?', '*', '|', '/', id, char, dec char, hex char, string",
            "expecting: '..', ';', '[', ']', '(', ')', '+', '-', '?', '*', '|', '/', id, char, dec char, hex char, string",
            "expecting: ';', ')', '|', '/'",
            "expecting: ';', '[', '(', ')', '|', '/', id, char, dec char, hex char, string",
            "expecting: ';', '[', '(', ')', '+', '?', '*', '|', '/', id, char, dec char, hex char, string",
            "expecting: ';', '[', ']', '(', ')', '+', '?', '*', '|', '/', id, char, dec char, hex char, string",
            "expecting: '}', ','",
            "expecting: ';', '/'",
            "expecting: '.'",
            "expecting: '->', id",
            "expecting: 'T', 'P', ';', '[', '{', '}', '+', '?', '*', '|', id",
            "expecting: ';', '|'",
            "expecting: 'T', 'P', ';', '[', '{', '}', '|', id",
            "expecting: 'T', 'P', id",
            "expecting: 'T', 'P', '[', '}', id",
            "expecting: id, EOF",
            "expecting: '+', '-'",
            "expecting: '..', '+', '-'",
            "expecting: ')'",
            "expecting: 'T', 'P', ';', '[', '(', ')', '{', '}', '|', '/', id, char, dec char, hex char, string",
            "expecting: ']'",
            "expecting: 'New', 'Null', 'T', 'P', '[', '}', id",
            "expecting: '}'",
            "expecting: char, dec char, hex char",
            "expecting: ':'",
            "expecting: 'New', 'Null', 'T', 'P', '[', ')', '}', ',', id",
            "expecting: 'New', 'T', 'P', ']', id",
            "expecting: 'New', 'Null', 'T', 'P', '.', '[', ')', '}', ',', id",
            "expecting: 'T', 'P', ';', '[', '|', id",
            "expecting: '.', '('",
            "expecting: '('",
            "expecting: '.', ']', ','",
            "expecting: ']', ','",
            "expecting: 'New', 'Null', 'T', 'P', '[', ')', id",
            "expecting: 'New', 'T', 'P', id",
            "expecting: 'New', 'Null', 'T', 'P', '[', ']', ')', '}', ',', id",
            "expecting: ')', ','",
            "expecting: 'New', 'Null', 'T', 'P', '[', id",
        };*/
    private static final int[] errors;
/*      {
            0, 1, 2, 2, 3, 4, 2, 5, 6, 7, 8, 9, 10, 11, 12, 6, 13, 7, 14, 15, 16, 17, 17, 2, 16, 18, 2, 18, 19, 20, 21, 21, 22, 8, 9, 10, 11, 12, 6, 9, 10, 11, 12, 6, 10, 11, 12, 6, 11, 12, 6, 12, 6, 6, 1, 7, 13, 13, 2, 14, 14, 9, 23, 17, 24, 25, 16, 18, 11, 15, 26, 27, 16, 21, 2, 9, 10, 11, 12, 6, 10, 11, 12, 6, 11, 12, 6, 12, 6, 6, 10, 11, 12, 6, 11, 12, 6, 12, 6, 6, 11, 12, 6, 12, 6, 6, 12, 6, 6, 6, 13, 7, 13, 14, 14, 28, 29, 30, 31, 31, 31, 30, 15, 32, 33, 34, 35, 30, 33, 2, 2, 2, 36, 36, 36, 37, 25, 11, 38, 38, 2, 39, 40, 15, 41, 41, 26, 42, 43, 2, 26, 44, 26, 16, 45, 45, 10, 11, 12, 6, 11, 12, 6, 12, 6, 6, 11, 12, 6, 12, 6, 6, 12, 6, 6, 6, 11, 12, 6, 12, 6, 6, 12, 6, 6, 6, 12, 6, 6, 6, 6, 46, 47, 48, 17, 33, 32, 32, 49, 49, 49, 33, 33, 24, 36, 2, 36, 2, 36, 18, 23, 15, 37, 2, 2, 50, 51, 52, 42, 21, 26, 41, 41, 27, 41, 26, 40, 2, 40, 41, 42, 16, 44, 15, 26, 45, 11, 12, 6, 12, 6, 6, 12, 6, 6, 6, 12, 6, 6, 6, 6, 12, 6, 6, 6, 6, 6, 28, 28, 28, 53, 30, 32, 32, 36, 2, 15, 18, 18, 15, 54, 2, 55, 56, 41, 57, 51, 2, 51, 26, 41, 41, 41, 42, 40, 42, 16, 21, 2, 58, 15, 41, 58, 12, 6, 6, 6, 6, 6, 6, 50, 50, 18, 43, 59, 60, 2, 55, 61, 50, 62, 2, 2, 55, 57, 41, 51, 42, 58, 45, 26, 41, 41, 6, 30, 30, 2, 60, 63, 60, 62, 55, 64, 62, 62, 61, 65, 55, 41, 41, 60, 55, 66, 48, 63, 62, 62, 62, 67, 66, 66, 55, 62, 48, 66, 66, 62, 
        };*/

    static
    {
        try
        {
            InputStream resStream = Parser.class.getResourceAsStream("parser.dat");
            if(resStream == null)
            {
                throw new RuntimeException("The file \"parser.dat\" is missing.");
            }
            DataInputStream s = new DataInputStream(new BufferedInputStream(resStream));

            // read actionTable
            int actionTableLength1 = s.readInt();
            actionTable = new int[actionTableLength1][][];
            for(int i = 0; i < actionTableLength1; i++)
            {
                int actionTableLength2 = s.readInt();
                actionTable[i] = new int[actionTableLength2][3];
                for(int j = 0; j < actionTableLength2; j++)
                {
                    for(int k = 0; k < 3; k++)
                    {
                        actionTable[i][j][k] = s.readInt();
                    }
                }
            }

            // read gotoTable
            int gotoTableLength1 = s.readInt();
            gotoTable = new int[gotoTableLength1][][];
            for(int i = 0; i < gotoTableLength1; i++)
            {
                int gotoTableLength2 = s.readInt();
                gotoTable[i] = new int[gotoTableLength2][2];
                for(int j = 0; j < gotoTableLength2; j++)
                {
                    for(int k = 0; k < 2; k++)
                    {
                        gotoTable[i][j][k] = s.readInt();
                    }
                }
            }

            // read errorMessages
            int errorMessagesLength = s.readInt();
            errorMessages = new String[errorMessagesLength];
            for(int i = 0; i < errorMessagesLength; i++)
            {
                int errorMessageLength = s.readInt();
                StringBuilder buffer = new StringBuilder();

                for(int j = 0; j < errorMessageLength; j++)
                {
                    buffer.append(s.readChar());
                }
                errorMessages[i] = buffer.toString();
            }

            // read errors
            int errorsLength = s.readInt();
            errors = new int[errorsLength];
            for(int i = 0; i < errorsLength; i++)
            {
                errors[i] = s.readInt();
            }

            s.close();
        }
        catch(IOException e)
        {
            throw new RuntimeException("The file \"parser.dat\" is either missing or corrupted.", e);
        }
    }
}
